package weaver.hrm.tools;
import com.alibaba.fastjson.JSON;
import com.api.hrm.util.ServiceUtil;
import com.engine.common.service.HrmCommonService;
import com.engine.common.service.impl.HrmCommonServiceImpl;
import com.engine.hrm.util.HrmTransMethod;
import com.engine.hrm.util.face.HrmFaceCheckManager;
import com.engine.kq.biz.KQBalanceOfLeaveBiz;
import com.engine.kq.biz.KQFormatData;
import weaver.common.DateUtil;
import weaver.common.StringUtil;
import weaver.hrm.autotask.domain.HrmUsbAutoDate;
import weaver.hrm.autotask.manager.HrmUsbAutoDateManager;
import weaver.hrm.common.DbFunctionUtil;
import weaver.hrm.common.database.dialect.DialectUtil;
import weaver.hrm.company.SubCompanyComInfo;
import weaver.hrm.resource.ResourceComInfo;
import weaver.system.SysRemindWorkflow;
import weaver.hrm.train.TrainComInfo;
import weaver.hrm.company.DepartmentComInfo;
import weaver.hrm.finance.SalaryManager;
import weaver.hrm.settings.ChgPasswdReminder;
import weaver.hrm.settings.RemindSettings;

import java.time.Duration;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;

import weaver.conn.*;
import weaver.file.*;
import weaver.general.*;
import weaver.rtx.OrganisationCom;
import weaver.crm.Maint.ContacterTitleComInfo;
import weaver.interfaces.hrm.HrmServiceManager;

/**
 * 人力资源后台检查线程
 */
public class HrmDateCheck extends BaseBean {

    public HrmDateCheck() {
    }

    private String typeid;
    String sql = "";
    String name = "";
    String accepter = "";
    String title = "";
    String remark = "";
    String submiter = "";
    String subject = "";
    SysRemindWorkflow srwf = new SysRemindWorkflow();

    Calendar todaycal = Calendar.getInstance();
    String today = Util.add0(todaycal.get(Calendar.YEAR), 4) + "-" +
            Util.add0(todaycal.get(Calendar.MONTH) + 1, 2) + "-" +
            Util.add0(todaycal.get(Calendar.DAY_OF_MONTH), 2);


    RecordSet rs = new RecordSet();
    RecordSet rs2 = new RecordSet();
    RecordSet rs3 = new RecordSet();

    ResourceComInfo rci = null;
    DepartmentComInfo dci = null;
    char separator = Util.getSeparator();
    OrganisationCom orgCom = new OrganisationCom();
    HrmServiceManager hrmaction = new HrmServiceManager();


    public void setResourceComInfo() {
        try {
            this.rci = new ResourceComInfo();
            this.dci = new DepartmentComInfo();
        } catch (Exception e) {
            writeLog(e);
        }
    }

    /**
     * 未使用，non-javadoc
     * @return
     */
    public String getTypeid() {
        return typeid;
    }

    /**
     * 未使用，non-javadoc
     * @param value
     */
    public void setTypeid(String value) {
        typeid = value;
    }

    /**
     * 检查日期并发送提醒
     */
    public void checkDate() {
        calWorkInfo();//计算工龄司龄
        checkUsbAutoDate();//检查动态令牌自动启用
        setResourceComInfo();
        //remindWorkFlow();
        //人员未知原因被离职，先注释离职服务，跟踪后续情况
        changeStatus();
        //probationRemindWorkFlow();
//        contractRemind();
        retireCheck();
//		contractCheck();
        fireCheck();
        //人员未知原因被离职，先注释离职服务，跟踪后续情况
        dismissCheck();
        rehireCheck();
        hireCheck();
        tryCheck();
        extendCheck();
        //probationWithoutContract();
        //worktimeWithoutContract();
        redeployCheck();
        trainLayoutAssessCheck();
        interviewAssessCheck();
        trainAssessCheck();
        examineCheck();
        birthdayCheck();

        setCapitalBorrowState();    // Added by lupeng 2004-07-26 for TD577.


        // 刘煜增加，清理工作流，文档共享部分的多余数据
//        delWrkMuti();

        /*更新员工假期余额*/
        KQBalanceOfLeaveBiz.createBalanceOfLeave();

        // 刘煜增加，清理人力资源的缓存
        rci.removeResourceCache();
        return;
    }

    /**
     * Set the capital state to "borrow",
     * Added by lupeng 2004-07-26 for TD577.
     */
    private void setCapitalBorrowState() {

        rs.executeProc("CptBorrowBuffer_Check", today);
    }

    /**
     * 对客户联系人进行生日提醒，如果设置了提前提醒的天数，那么就重达到提前天数的那一天开始到上日那一天结束每天进行提醒
     */
    private void birthdayCheck(){

        try {
            ResourceComInfo rci = new ResourceComInfo();
            ContacterTitleComInfo ctci = new ContacterTitleComInfo();
            String sql = "select t1.id, t1.customerid, t1.title, t1.firstname, t2.manager, t1.birthday, t1.birthdaynotifydays from CRM_CustomerContacter t1, CRM_CustomerInfo t2 where t2.deleted =0 and t1.customerid=t2.id and t1.birthdaynotifydays is not null and t1.birthday != '' ";
            if(!rs.getDBType().equals("oracle"))
                sql=sql+" and t1.birthday<>'' ";
            rs.executeSql(sql);

            Calendar cal = null;
            Calendar cal2 = null;
            Calendar cal3 = null;

            String content = "";
            content = ""+weaver.systeminfo.SystemEnv.getHtmlLabelName(10003685, ThreadVarLanguage.getLang())+":";
            String temDate = "";
            int temMonth = 0;
            int temDay = 0;
            int days = 0;
            int beginYear = 0;
            int endYear = 0;
            while(rs.next()){
                cal = Calendar.getInstance();
                cal2 = Calendar.getInstance();
                cal3 = Calendar.getInstance();

                temDate = rs.getString("birthday");
                if(temDate.length()<10){
                    continue;
                }
                temMonth = Integer.parseInt(temDate.substring(5, 7));
                temDay = Integer.parseInt(temDate.substring(8, 10));
                days = rs.getInt("birthdaynotifydays");
                beginYear = cal.get(Calendar.YEAR);
                cal.add(Calendar.DAY_OF_MONTH,days);
                endYear = cal.get(Calendar.YEAR);

                cal2.set(Calendar.YEAR,beginYear);
                cal2.set(Calendar.MONTH,temMonth-1);
                cal2.set(Calendar.DAY_OF_MONTH,temDay);

                if(cal3.getTime().getTime() <=cal2.getTime().getTime() && cal.getTime().getTime()>=cal2.getTime().getTime()){
                    srwf.setCRMSysRemind(content+rs.getString("firstname")+" "+rs.getString("birthday")+" "+weaver.systeminfo.SystemEnv.getHtmlLabelName(1964, ThreadVarLanguage.getLang())+"", rs.getInt("customerid"), rs.getInt("manager"), String.valueOf(rs.getInt("manager")),"");
                }else if(beginYear != endYear){
                    cal2.set(Calendar.YEAR,endYear);
                    cal2.set(Calendar.MONTH,temMonth-1);
                    cal2.set(Calendar.DAY_OF_MONTH,temDay);
                    if(cal3.getTime().getTime() <=cal2.getTime().getTime() && cal.getTime().getTime()>=cal2.getTime().getTime()){
                        srwf.setCRMSysRemind(content+rs.getString("firstname")+" "+rs.getString("birthday")+" "+weaver.systeminfo.SystemEnv.getHtmlLabelName(1964, ThreadVarLanguage.getLang())+"", rs.getInt("customerid"), rs.getInt("manager"), String.valueOf(rs.getInt("manager")),"");
                    }
                }

            }
        } catch (Exception e) {
            writeLog(this.getClass().getName(),e);
        }

    }

    /**
     * add by dongping 2004.11.2 for fixed bug facility
     * 人力资源中用到的，相应的人员状态如下：
     * 试用　　　：　０
     * 正式　　　：　１
     * 临时　　　：　２
     * 试用延期　：　３
     * 解聘     :  4
     * 离职     :  5
     * 退休     :  6
     * 无效     :  7
     */

    private void remindWorkFlow() {//合同到期提醒
        try {
            //            sql = "select HrmContract.id,remindman from HrmContract,HrmContractType where datediff(day,contractenddate,getdate())=remindaheaddate and contracttypeid = HrmContractType.id";
            //sql = "select HrmContract.id,remindman,contractenddate,remindaheaddate,contractman from HrmContract,HrmContractType where  contracttypeid = HrmContractType.id";

            sql = "select HrmContract.id,remindman,contractenddate,remindaheaddate,contractman" +
                    " from HrmContract,HrmContractType,HrmResource where  contracttypeid = HrmContractType.id and " +
                    " HrmResource.id = HrmContract.contractman and HrmResource.status in (0,1,2,3) ";
            rs.executeSql(sql);
            //            ResourceComInfo rci = new ResourceComInfo();
            while (rs.next()) {
                String id = rs.getString(1);
                String infoman = rs.getString("remindman");
                String contractman = Util.null2String(rs.getString("contractman"));
                String contractenddate = Util.null2String(rs.getString("contractenddate"));
                int remindaheaddate = Util.getIntValue(rs.getString("remindaheaddate"));
                /**
                 * Modified By Charoes Huang    On May 18,2004
                 * Util.dayDiff(startdate ,enddate) 返回的天数比实际多一天！
                 * 即如果 startdate == enddate ，返回 1 ，实际应该是零
                 */
                if (Util.dayDiff(today, contractenddate) != (remindaheaddate + 1)) continue;
                subject = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(15783, ThreadVarLanguage.getLang())+"", 7, "0");
                subject += ":" + rci.getResourcename(contractman);
                infoman += ",";
                ArrayList al = Util.TokenizerString(infoman, ",");
                for (int i = 0; i < al.size(); i++) {
                    //                while(infoman.indexOf(",")>0){
                    //                    int index = infoman.indexOf(",");
                    //                    accepter = infoman.substring(0,index);
                    //                    infoman = infoman.substring(index+1,infoman.length());
                    accepter = (String) al.get(i);
                    title = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(15783, ThreadVarLanguage.getLang())+"", 7, "0");
                    title += ": ";
                    title += "-" + rci.getResourcename(contractman);
                    title += "-" + today;
                    remark = "<a href='"+ GCONST.getContextPath()+"/hrm/contract/contract/HrmContractView.jsp?id=" + id + "'>" + Util.fromScreen2(subject, 7) + "</a>";
                    submiter = "1";
                    srwf.setPrjSysRemind(title, 0, Util.getIntValue(submiter), accepter, remark);
                }
            }
        } catch (Exception e) {
            writeLog(e);
        }
    }

    private void probationRemindWorkFlow() {//试用期到期提醒
        boolean isoracle = rs.getDBType().equals("oracle");
        try {
            //            sql = "select HrmContract.id,remindman from HrmContract,HrmContractType where datediff(day,proenddate,getdate()) = remindaheaddate and contracttypeid = HrmContractType.id and proenddate <> ''";
            //sql = "select HrmContract.id,remindman,proenddate,remindaheaddate,contractman from HrmContract,HrmContractType where contracttypeid = HrmContractType.id and proenddate <> ''";

            sql = "select HrmContract.id,remindman,proenddate,remindaheaddate,contractman from " +
                    "HrmContract,HrmContractType,HrmResource where contracttypeid = HrmContractType.id and proenddate <> '' and" +
                    " HrmResource.id = HrmContract.contractman and HrmResource.status in (0,3) ";

            if (isoracle) {
                //            sql = "select HrmContract.id,remindman from HrmContract,HrmContractType where datediff(day,proenddate,getdate())=remindaheaddate and contracttypeid = HrmContractType.id and proenddate is not null";
                // sql = "select HrmContract.id,remindman,proenddate,remindaheaddate,contractman from HrmContract,HrmContractType where contracttypeid = HrmContractType.id and proenddate is not null";

                sql = "select HrmContract.id,remindman,proenddate,remindaheaddate,contractman from HrmContract,HrmContractType,HrmResource " +
                        "where contracttypeid = HrmContractType.id and proenddate is not null and " +
                        " HrmResource.id = HrmContract.contractman and HrmResource.status in (0,3) ";


            }
            rs.executeSql(sql);
            //            ResourceComInfo rci = new ResourceComInfo();
            while (rs.next()) {
                String id = rs.getString(1);
                String infoman = rs.getString("remindman");
                String contactman = Util.null2String(rs.getString("contractman"));
                String proenddate = Util.null2String(rs.getString("proenddate"));
                int remindaheaddate = Util.getIntValue(rs.getString("remindaheaddate"));
                /**
                 * Modified by Charoes Huang     on May 18,2004
                 */
                if (Util.dayDiff(today, proenddate) != (remindaheaddate + 1)) continue;
                infoman += ",";
                ArrayList al = Util.TokenizerString(infoman, ",");
                for (int i = 0; i < al.size(); i++) {
                    //                while(infoman.indexOf(",")>0){
                    //                    int index = infoman.indexOf(",");
                    //                    accepter = infoman.substring(0,index);
                    //                    infoman = infoman.substring(index+1,infoman.length());
                    accepter = (String) al.get(i);

                    subject = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(15784, ThreadVarLanguage.getLang())+"", 7, "0");
                    subject += ":" + rci.getResourcename(contactman);
                    title = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(15784, ThreadVarLanguage.getLang())+"", 7, "0");
                    title += ": ";
                    title += "-" + rci.getResourcename(contactman);
                    title += "-" + today;
                    remark = "<a href='"+ GCONST.getContextPath()+"/hrm/contract/contract/HrmContractView.jsp?id=" + id + "'>" + Util.fromScreen2(subject, 7) + "</a>";
                    submiter = "1";
                    srwf.setPrjSysRemind(title, 0, Util.getIntValue(submiter), accepter, remark);
                }
            }
        } catch (Exception e) {
            writeLog(e);
        }
    }

    private void probationWithoutContract() {//试用期到期提醒,没有合同
        ChgPasswdReminder reminder=new ChgPasswdReminder();
        RemindSettings settings=reminder.getRemindSettings();
        if(!settings.getContractvalid().equals("1"))return;//是否开启提醒
        String contractremindperiod = Util.null2String(settings.getContractremindperiod());
        if(contractremindperiod.length()==0)contractremindperiod="3";//默认提前3天和原来一致
        int remindaheaddate = Integer.parseInt(contractremindperiod);
        try {
            sql = "select id,probationenddate,lastname from HrmResource where status in (0,3)";
            rs.executeSql(sql);
            //        ResourceComInfo rci = new ResourceComInfo();
            while (rs.next()) {
                String id = Util.null2String(rs.getString("id"));
                if (hasContract(id)) continue;
                String enddate = Util.null2String(rs.getString("probationenddate"));
                /**
                 * Modified By Charoes Huang, On May 18,2004
                 */
                if (Util.dayDiff(today, enddate) != (remindaheaddate + 1)) continue;

                String infoman = getHrmId(id);
                String name = Util.null2String(rs.getString("lastname"));
                ArrayList al = Util.TokenizerString(infoman, ",");
                for (int i = 0; i < al.size(); i++) {
                    accepter = (String) al.get(i);
                    //          System.out.println("the accepter is "+accepter);
                    subject = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(15784, ThreadVarLanguage.getLang())+"", 7, "0");
                    subject += ":" + name;
                    title = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(15784, ThreadVarLanguage.getLang())+"", 7, "0");
                    title += ": ";
                    //          title += "-"+rci.getResourcename(accepter);
                    title += "-" + name;
                    title += "-" + today;
                    remark = "<a href='"+ GCONST.getContextPath()+"/hrm/resource/HrmResource.jsp?id=" + id + "'>" + Util.fromScreen2(subject, 7) + "</a>";
                    submiter = "1";
                    srwf.setPrjSysRemind(title, 0, Util.getIntValue(submiter), accepter, remark);
                }
            }
        } catch (Exception e) {
            writeLog(e);
        }
    }

    private void worktimeWithoutContract() {//工作合同到期提醒,没有合同
        ChgPasswdReminder reminder=new ChgPasswdReminder();
        RemindSettings settings=reminder.getRemindSettings();
        if(!settings.getContractvalid().equals("1"))return;//是否开启提醒
        String contractremindperiod = Util.null2String(settings.getContractremindperiod());
        if(contractremindperiod.length()==0)contractremindperiod="3";//默认提前3天和原来一致
        int remindaheaddate = Integer.parseInt(contractremindperiod);
        try {
            sql = "select id,enddate,lastname from HrmResource where status in (0,1,2,3)";
            rs.executeSql(sql);
            //        ResourceComInfo rci = new ResourceComInfo();
            while (rs.next()) {
                String id = Util.null2String(rs.getString("id"));
                if (hasContract(id)) continue;
                String enddate = Util.null2String(rs.getString("enddate"));
                /**
                 * Modified by Charoes Huang on May 18,2004
                 */
                if (Util.dayDiff(today, enddate) != (remindaheaddate + 1)) continue;

                String infoman = getHrmId(id);
                String name = Util.null2String(rs.getString("lastname"));
                ArrayList al = Util.TokenizerString(infoman, ",");
                for (int i = 0; i < al.size(); i++) {
                    accepter = (String) al.get(i);
                    //          System.out.println("the accepter is "+accepter);
                    subject = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(15783, ThreadVarLanguage.getLang())+"", 7, "0");
                    subject += ":" + name;
                    title = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(15783, ThreadVarLanguage.getLang())+"", 7, "0");
                    title += ": ";
                    //          title += "-"+rci.getResourcename(accepter);
                    title += "-" + name;
                    title += "-" + today;
                    remark = "<a href='"+ GCONST.getContextPath()+"/hrm/resource/HrmResource.jsp?id=" + id + "'>" + Util.fromScreen2(subject, 7) + "</a>";
                    submiter = "1";
                    srwf.setPrjSysRemind(title, 0, Util.getIntValue(submiter), accepter, remark);
                }
            }
        } catch (Exception e) {
            writeLog(e);
        }
    }

    public String getHrmId(String id) {
        String hrm = "";
        try {
            //String sql = "select distinct(resourceid),rolelevel from HrmRoleMembers where roleid = 4";
            String sql = " SELECT resourceid,rolelevel FROM ( "+
                    " SELECT distinct a.id AS resourceid, b.roleid , b.rolelevel FROM HrmResource a, HrmRoleMembers b "+
                    " WHERE (a.id=b.resourceid and b.resourcetype=1) "+
                    " UNION ALL "+
                    " SELECT a.id AS resourceid, b.roleid , b.rolelevel FROM HrmResourceManager a, HrmRoleMembers b "+
                    " WHERE (a.id=b.resourceid and b.resourcetype IN(7,8)) "+
                    " UNION ALL "+
                    " SELECT a.id AS resourceid, b.roleid , b.rolelevel FROM HrmResource a, HrmRoleMembers b "+
                    " WHERE (a.subcompanyid1 = b.resourceid AND a.seclevel>=b.seclevelfrom AND a.seclevel<=b.seclevelto AND b.resourcetype=2) "+
                    " UNION ALL "+
                    " SELECT a.id AS resourceid, b.roleid , b.rolelevel FROM HrmResource a, HrmRoleMembers b "+
                    " WHERE (a.departmentid = b.resourceid AND a.seclevel>=b.seclevelfrom AND a.seclevel<=b.seclevelto AND b.resourcetype=3) "+
                    " UNION ALL "+
                    " SELECT a.id AS resourceid, b.roleid , b.rolelevel FROM HrmResource a, HrmRoleMembers b "+
                    " WHERE  (a.jobtitle = b.resourceid AND b.resourcetype=5 AND (b.jobtitlelevel=1 OR (b.jobtitlelevel=2 AND a.subcompanyid1 IN(b.subdepid)) OR (b.jobtitlelevel=3 AND a.departmentid IN(b.subdepid))))) t "+
                    " WHERE roleid= "+4;
            rs2.executeSql(sql);
            while (rs2.next()) {
                String resourceid = Util.null2String(rs2.getString("resourceid"));
                int rolelevel = Util.getIntValue(rs2.getString("rolelevel"));
                if (rolelevel == 2) {
                    hrm += resourceid + ",";
                    continue;
                }
                if (rolelevel == 1) {
                    DepartmentComInfo dci = new DepartmentComInfo();
                    String subcomid = dci.getSubcompanyid1(rci.getDepartmentID(id));
                    String subcomid2 = dci.getSubcompanyid1(rci.getDepartmentID(resourceid));
                    if (subcomid.equals(subcomid2)) {
                        hrm += resourceid + ",";
                        continue;
                    }
                }
                if (rolelevel == 0) {
                    String departmentid = rci.getDepartmentID(id);
                    String departmentid2 = rci.getDepartmentID(resourceid);
                    if (departmentid.equals(departmentid2)) {
                        hrm += resourceid + ",";
                        continue;
                    }
                }
            }
        } catch (Exception e) {
            writeLog(e);
        }
        if (hrm.equals("")) {
            return "";
        }
        //    System.out.println("the hrm in function is "+hrm);
        return hrm.substring(0, hrm.length() - 1);
    }

    public boolean hasContract(String id) {
        try {
            String sql = "select ishirecontract from HrmContractType where id in(select contracttypeid from HrmContract where contractman = " + id + ")";
            rs2.executeSql(sql);
            while (rs2.next()) {
                int ishire = Util.getIntValue(rs2.getString("ishirecontract"), 0);
                if (ishire == 1) {
                    return true;
                }
            }
        } catch (Exception e) {
            writeLog(e);
        }
        return false;
    }

    public void changeStatus() {//改变状态

        ChgPasswdReminder reminder=new ChgPasswdReminder();
        RemindSettings settings=reminder.getRemindSettings();
        String statusWithContract=settings.getStatusWithContract();
        if("1".equals(statusWithContract)){//开关打开，就是合同到期后，将人员状态置为无效；关闭就是，合同到期后不改变人员状态 默认关闭！
            RecordSet recordSet = new RecordSet();
            String sql = "select id,enddate,jobtitle from HrmResource where (status = 0 or status = 1 or status = 2 or status = 3) and enddate <= '"+today+"'";
            if(rs.getDBType().equalsIgnoreCase("oracle") || DialectUtil.isMySql(rs.getDBType())){
                sql += " and enddate is not null ";
            }else{
                sql += " AND enddate <> '' AND enddate IS NOT NULL ";
            }
            writeLog("HrmResourceDateCheck。sql1="+sql);
            rs.executeQuery(sql);
            while(rs.next()){
                sql = "insert into HrmStatusHistory(resourceid,changedate,changereason,changecontractid,infoman,oldjobtitleid,type_n,operator,isdispose) " +
                        "values("+rs.getString("id")+",'"+rs.getString("enddate")+"','合同到期人员置为无效','','',"+rs.getString("jobtitle")+",9,1,1)";
                writeLog("HrmResourceDateCheck。sql2="+sql);
                recordSet.executeUpdate(sql);
            }
            Boolean bool=rs.executeProc("HrmResourceDateCheck", today);
            writeLog("HrmResourceDateCheck执行成功。bool="+bool);
        }else{
            rs.executeProc("HrmResourceDateCheck7", today);//HrmResourceDateCheck7  新增的存储过程，不会去更新人员状态为7 无效
        }
    }
    public void contractCheck(){ //合同到期
        sql = "select id,loginid from hrmresource where  status = '7'";
        rs.executeSql(sql);
        while(rs.next()){
            int id = rs.getInt(1);
            String loginid = rs.getString(2);
            boolean exist = orgCom.checkUser(id);
            if(exist){
                orgCom.deleteUser2(id);
            }
        }
    }

    /**
     * 判断这个人在变更日期之后是否已经发生过状态变更
     * @param resourceid
     * @param changedate
     * @return true表示不需要再变更了，false表示可以继续变更
     */
    public boolean hasStatueChanged(String resourceid, String changedate){
        String closeStatueChanged = Util.null2String(Prop.getPropValue("Others","closeStatueChanged")) ;
        if("1".equals(closeStatueChanged)){
            return false ;
        }

        boolean hasChanged = false;
        RecordSet rs = new RecordSet();
        //判断这个人在变更日期之后是否已经发生过状态变更
        String hasChangedSql = "select 1 from HrmStatusHistory where isdispose = 1 and type_n in (6,1,5,7,2,8,3) and resourceid = "+resourceid+" and changedate > '"+changedate+"'";
        rs.executeSql(hasChangedSql);
        if(rs.next()){
            hasChanged = true;
        }
        return hasChanged;
    }

    private void retireCheck() {//退休
        try {
            //        ResourceComInfo rci = new ResourceComInfo();
            sql = "select id,resourceid,changedate,operator from HrmStatusHistory where type_n = 6 and isdispose = 0";

            rs.executeSql(sql);
            while (rs.next()) {
                String id = Util.null2String(rs.getString("resourceid"));
                String changedate = Util.null2String(rs.getString("changedate"));
                String operator = Util.null2String(rs.getString("operator"));
                if (compareDate(changedate)) {
                    if (!rci.getStatus(id).equals("6")) {
                        if(hasStatueChanged(id, changedate)){
                            continue;
                        }
                        //add by chengfeng.han 2011-7-18 27152 如果离职日期和当前日期比较小于等于1天，就立即执行离职的相关处理
                        rs2.executeSql("delete from hrmrolemembers where resourcetype=1 and resourceid="+id);
                        //删除手机版中设置的登录人员
                        rs2.executeSql("delete from PluginLicenseUser where plugintype='mobile' and sharetype='0' and sharevalue='"+id+"'");
                        //end
                        rs2.executeSql("delete from hrmgroupmembers where userid="+id);

                        //jiajun.zhou 2014-09-26 QC116879  如果日期大于1天，解决离职/退休/解聘人员，使用的是定时任务，不会清除ad域账号的问题
                        sql = "update HrmResource set status = 6 ,loginid='',password='',account='',tokenkey='',lastmoddate='"+changedate+"',lastmodid='"+operator+"' where id = " + id;

                        rs2.executeSql(sql);
                        sql = "update HrmStatusHistory set isdispose = 1 where id=" + rs.getString("id");

                        rs2.executeSql(sql);

                        sql = "update HrmResource set "+ DbFunctionUtil.getUpdateSetSql(rs2.getDBType(),Util.getIntValue(operator,0))+" where id = "+id;
                        rs2.executeSql(sql);

                        boolean exist = orgCom.checkUser(Integer.parseInt(id));
                        if(exist){
                            orgCom.deleteUser2(Integer.parseInt(id));
                        }

                        try{
                            //离职注销发票云
                            HrmCommonService hcs = new HrmCommonServiceImpl();
                            hcs.unbindInvoiceCloud(Util.getIntValue(id));

                            //离职之后下线EM
                            ServiceUtil serviceUtil = new ServiceUtil();
                            serviceUtil.emOffline(id);
                        }catch (Exception e){
                            writeLog(e);
                        }
                        //OA与第三方接口单条数据同步方法开始
                        hrmaction.SynInstantHrmResource(id,"3");
                        //OA与第三方接口单条数据同步方法结束

                        HrmFaceCheckManager.sync(id,HrmFaceCheckManager.getOptUpdate(),this.getClass().getName(),HrmFaceCheckManager.getOaResource());
                    }
                }
            }
        } catch (Exception e) {
            writeLog(e);
        }
    }

    private void fireCheck() {//解聘
        try {
            //        ResourceComInfo rci = new ResourceComInfo();
            sql = "select id,resourceid,changedate,operator from HrmStatusHistory where type_n = 1 and isdispose = 0";
            rs.executeSql(sql);
            while (rs.next()) {
                String id = Util.null2String(rs.getString("resourceid"));
                String changedate = Util.null2String(rs.getString("changedate"));
                String operator = Util.null2String(rs.getString("operator"));
                if (compareDate(changedate)) {
                    if (!rci.getStatus(id).equals("4")) {
                        if(hasStatueChanged(id, changedate)){
                            continue;
                        }
                        //add by chengfeng.han 2011-7-18 27152 如果离职日期和当前日期比较小于等于1天，就立即执行离职的相关处理
                        rs2.executeSql("delete from hrmrolemembers where resourcetype=1 and resourceid="+id);
                        //删除手机版中设置的登录人员
                        rs2.executeSql("delete from PluginLicenseUser where plugintype='mobile' and sharetype='0' and sharevalue='"+id+"'");
                        //end
                        rs2.executeSql("delete from hrmgroupmembers where userid="+id);

                        //jiajun.zhou 2014-09-26 QC116879  如果日期大于1天，解决离职/退休/解聘人员，使用的是定时任务，不会清除ad域账号的问题
                        sql = "update HrmResource set  status = 4 ,loginid='',password='',account='',tokenkey='',lastmoddate='"+changedate+"',lastmodid='"+operator+"'  where id = " + id;

                        rs2.executeSql(sql);
                        sql = "update HrmStatusHistory set isdispose = 1 where id=" + rs.getString("id");

                        rs2.executeSql(sql);

                        sql = "update HrmResource set "+ DbFunctionUtil.getUpdateSetSql(rs2.getDBType(),Util.getIntValue(operator,0))+" where id = "+id;
                        rs2.executeSql(sql);

                        boolean exist = orgCom.checkUser(Integer.parseInt(id));
                        if(exist){
                            orgCom.deleteUser2(Integer.parseInt(id));
                        }
                        try{
                            //离职注销发票云
                            HrmCommonService hcs = new HrmCommonServiceImpl();
                            hcs.unbindInvoiceCloud(Util.getIntValue(id));

                            //离职之后下线EM
                            ServiceUtil serviceUtil = new ServiceUtil();
                            serviceUtil.emOffline(id);
                        }catch (Exception e){
                            writeLog(e);
                        }

                        //OA与第三方接口单条数据同步方法开始
                        hrmaction.SynInstantHrmResource(id,"3");
                        //OA与第三方接口单条数据同步方法结束

                        HrmFaceCheckManager.sync(id,HrmFaceCheckManager.getOptUpdate(),this.getClass().getName(),HrmFaceCheckManager.getOaResource());
                    }
                }
            }
        } catch (Exception e) {
            writeLog(e);
        }
    }

    private void dismissCheck() {//离职
        try {
            //        ResourceComInfo rci = new ResourceComInfo();
            sql = "select id,resourceid,changedate,operator  from HrmStatusHistory where type_n = 5 and isdispose = 0";

            rs.executeSql(sql);
            while (rs.next()) {
                String id = rs.getString("resourceid");
                String changedate = rs.getString("changedate");
                String operator = rs.getString("operator");
                String oldDepartmentId = rci.getDepartmentID(id);
                if (compareDate(changedate)) {
                    if (!rci.getStatus(id).equals("5")) {
                        if(hasStatueChanged(id, changedate)){
                            continue;
                        }
                        //add by chengfeng.han 2011-7-18 27152 如果离职日期和当前日期比较小于等于1天，就立即执行离职的相关处理
                        rs2.executeSql("delete from hrmrolemembers where resourcetype=1 and resourceid="+id);
                        //删除手机版中设置的登录人员
                        rs2.executeSql("delete from PluginLicenseUser where plugintype='mobile' and sharetype='0' and sharevalue='"+id+"'");
                        //end

                        //jiajun.zhou 2014-09-26 QC116879  如果日期大于1天，解决离职/退休/解聘人员，使用的是定时任务，不会清除ad域账号的问题
                        sql = "update HrmResource set status = 5 ,loginid='',password='',account='',tokenkey='',lastmoddate='"+changedate+"',lastmodid='"+operator+"' where id = " + id;
                        rs2.writeLog(">>>111 dismissdatecheck: sql:"+sql);
                        boolean a = rs2.executeSql(sql);
                        rs2.writeLog(">>>222 dismissdatecheck: a:"+a);

//                        int userid = 1;
//                        String userpara = "" + userid + separator + changedate;
//                        rs2.executeProc("HrmResource_ModInfo", "" + id + separator + userpara);

                        sql="delete hrmgroupmembers where userid="+id;
                        rs2.executeSql(sql);
                        sql = "update HrmStatusHistory set isdispose = 1, oldDepartmentId="+oldDepartmentId+" where id=" + rs.getString("id");
                        rs2.executeSql(sql);

                        sql = "update HrmResource set "+ DbFunctionUtil.getUpdateSetSql(rs2.getDBType(),Util.getIntValue(operator,0))+" where id = "+id;
                        rs2.executeSql(sql);

                        try{
                            //离职注销发票云
                            HrmCommonService hcs = new HrmCommonServiceImpl();
                            hcs.unbindInvoiceCloud(Util.getIntValue(id));

                            //离职之后下线EM
                            ServiceUtil serviceUtil = new ServiceUtil();
                            serviceUtil.emOffline(id);
                        }catch (Exception e){
                            writeLog(e);
                        }

						try{
							rci.removeResourceCache();
							String changefirstdate = DateUtil.getFirstDayOfMonth(changedate);
							String changelastdate = DateUtil.getLastDayOfMonth(changedate);
							String endDate = Util.null2String(rci.getEndDate(id));
							String endfirstdate = DateUtil.getFirstDayOfMonth(endDate);
							String endlastdate = DateUtil.getLastDayOfMonth(endDate);
							if(changefirstdate!=null && changefirstdate.compareTo(endfirstdate)<=0){
								new HrmDateCheck().calKqData(changefirstdate,endlastdate,id);
							}else{
								new HrmDateCheck().calKqData(endfirstdate,changelastdate,id);
							}
						}catch(Exception e){
							writeLog(e);
						}

                        boolean exist = orgCom.checkUser(Integer.parseInt(id));
                        if(exist){
                            orgCom.deleteUser2(Integer.parseInt(id));
                        }

                        //OA与第三方接口单条数据同步方法开始
                        hrmaction.SynInstantHrmResource(id,"3");
                        //OA与第三方接口单条数据同步方法结束
                        HrmFaceCheckManager.sync(id,HrmFaceCheckManager.getOptUpdate(),this.getClass().getName(),HrmFaceCheckManager.getOaResource());
                    }
                }
            }
        } catch (Exception e) {
            writeLog(e);
        }
    }

    private void rehireCheck() {//返聘
        try {
            String subcmpanyid1 = "-1";
            String newmanagerid = null;
            String joblevel = null;
            String jobtitle = null;
            int newDepartmentId=0;
            //        ResourceComInfo rci = new ResourceComInfo();
            sql = "select * from HrmStatusHistory where type_n = 7 and isdispose = 0";

            rs.executeSql(sql);
            while (rs.next()) {
                String id = Util.null2String(rs.getString("resourceid"));
                String changedate = Util.null2String(rs.getString("changedate"));
                String changeenddate = Util.null2String(rs.getString("changeenddate")).trim();
                newDepartmentId = Util.getIntValue(rs.getString("newDepartmentId"),-1);
                joblevel = Util.null2String(rs.getString("newjoblevel"));
                jobtitle = Util.null2String(rs.getString("newjobtitleid"));
                newmanagerid = Util.null2String(rs.getString("newmanagerid"));
                String operator = rs.getString("operator");
				int rehireStatus = Util.getIntValue(rs.getString("type_o"), 1);
                String tempmanagerid=newmanagerid;
                if (compareDate(changedate)) {
                    if (!rci.getStatus(id).equals("1")) {
                        if(hasStatueChanged(id, changedate)){
                            continue;
                        }
                        int  costcenterid = 0;
                        String managerstr = "";
                        String para = ""+id+separator+""+newDepartmentId+separator+""+joblevel+separator+""+costcenterid+separator+""+jobtitle+separator+""+newmanagerid;
                        rs2.executeProc("HrmResource_DepUpdate",para);
                        subcmpanyid1 = dci.getSubcompanyid1(""+newDepartmentId);
                        para = ""+id+separator+subcmpanyid1;
                        rs2.executeProc("HrmResource_UpdateSubCom",para);

                        if(!"".equals(tempmanagerid)){
                            /*更新managerstr*/
                            if(!id.equals(tempmanagerid)){
                                rs2.executeSql("select managerstr from HrmResource where id = "+Util.getIntValue(newmanagerid));
                                while(rs2.next()){
                                    managerstr = rs2.getString("managerstr");
                                    /*********处理managerstr 不以逗号开始或者结束的情况 形如 managerstr：8 begin***********/
                                    if(!managerstr.startsWith(","))managerstr=","+managerstr;
                                    if(!managerstr.endsWith(","))managerstr=managerstr+",";
                                    /*********处理managerstr 不以逗号开始或者结束的情况 形如 managerstr：8 end ***********/
                                    managerstr =","+newmanagerid+managerstr;
                                    managerstr =managerstr.endsWith(",")?managerstr:(managerstr+",");
                                }
                            }else{
                                managerstr =","+newmanagerid+",";
                            }
                            para = ""+id+separator+ managerstr;
                            rs2.executeProc("HrmResource_UpdateManagerStr",para);
                        }

                        sql = "update HrmResource set status = "+rehireStatus+" where id = " + id;

                        rs2.executeSql(sql);
                        //if(StringUtil.isNull(changeenddate))
						rci.updateResourceInfoCache(id);
						sql = "update HrmStatusHistory set isdispose = 1 where id=" + rs.getString("id");

                        rs2.executeSql(sql);

                        sql = "update HrmResource set "+ DbFunctionUtil.getUpdateSetSql(rs2.getDBType(),Util.getIntValue(operator,0))+",lastmoddate='"+changedate+"',lastmodid='"+operator+"' where id = "+id;
                        rs2.executeSql(sql);

                        boolean exist = orgCom.checkUser(Integer.parseInt(id));
                        if(exist){
                            orgCom.editUser(Integer.parseInt(id));
                        } else {
                            orgCom.addUser(Integer.parseInt(id));
                        }
                    }else{//正式 返聘日期结束 改为离职
                        if(changeenddate.length()>0){
                            if(compareDate(changeenddate)){
                                sql = "update HrmResource set status = 5 where id = ? " ;
                                rs2.executeUpdate(sql,id);
                                sql = "update HrmStatusHistory set isdispose = 1 where id= ? ";
                                rs2.executeUpdate(sql,rs.getString("id"));
                                sql = "update HrmResource set "+ DbFunctionUtil.getUpdateSetSql(rs2.getDBType(),0)+",lastmoddate='"+changedate+"',lastmodid='"+operator+"' where id = "+id;
                                rs2.executeSql(sql);
                                boolean exist = orgCom.checkUser(Integer.parseInt(id));
                                if(exist){
                                    orgCom.editUser(Integer.parseInt(id));
                                } else {
                                    orgCom.addUser(Integer.parseInt(id));
                                }
                            }
                        }else{
                            sql = "update HrmStatusHistory set isdispose = 1 where id= ? ";
                            rs2.executeUpdate(sql,rs.getString("id"));
                        }
                    }
                }
                HrmFaceCheckManager.sync(id,HrmFaceCheckManager.getOptUpdate(),this.getClass().getName(),HrmFaceCheckManager.getOaResource());
            }
        } catch (Exception e) {
            writeLog(e);
        }
    }

    private void hireCheck() {//转正
        try {
            //      ResourceComInfo rci = new ResourceComInfo();
            sql = "select id,resourceid,changedate,operator from HrmStatusHistory where type_n = 2 and isdispose = 0";

            rs.executeSql(sql);
            while (rs.next()) {
                String id = Util.null2String(rs.getString("resourceid"));
                String changedate = Util.null2String(rs.getString("changedate"));
                String operator = Util.null2String(rs.getString("operator"));
                if (compareDate(changedate)) {
                    if (Util.getIntValue(rci.getStatus(id))<=3) {
                        if(hasStatueChanged(id, changedate)){
                            continue;
                        }
                        sql = "update HrmResource set status = 1 where id = " + id;

                        rs2.executeSql(sql);
                        rci.updateResourceInfoCache(id);
                        sql = "update HrmStatusHistory set isdispose = 1 where id=" + rs.getString("id");

                        rs2.executeSql(sql);
                        sql = "update HrmResource set "+ DbFunctionUtil.getUpdateSetSql(rs2.getDBType(),Util.getIntValue(operator,0))+",lastmoddate='"+changedate+"',lastmodid='"+operator+"' where id = "+id;
                        rs2.executeSql(sql);

                        orgCom.checkUser(Integer.parseInt(id));

                        HrmFaceCheckManager.sync(id,HrmFaceCheckManager.getOptUpdate(),this.getClass().getName(),HrmFaceCheckManager.getOaResource());
                    }else{
						 sql = "update HrmStatusHistory set isdispose = 1 where id=" + rs.getString("id");	
						 rs2.executeSql(sql) ;
					}
                }
            }
        } catch (Exception e) {
            writeLog(e);
        }
    }

    private void tryCheck() {//转正
        try {
            //      ResourceComInfo rci = new ResourceComInfo();
            sql = "select id,resourceid,changedate,operator from HrmStatusHistory where type_n = 8 and isdispose = 0";

            rs.executeSql(sql);
            while (rs.next()) {
                String id = Util.null2String(rs.getString("resourceid"));
                String changedate = Util.null2String(rs.getString("changedate"));
                String operator = Util.null2String(rs.getString("operator"));
                if (compareDate(changedate)) {
                    if (!rci.getStatus(id).equals("0")) {
                        if(hasStatueChanged(id, changedate)){
                            continue;
                        }
                        sql = "update HrmResource set status = 0 where id = " + id;

                        rs2.executeSql(sql);
                        rci.updateResourceInfoCache(id);
                        sql = "update HrmStatusHistory set isdispose = 1 where id=" + rs.getString("id");
                        rs2.executeSql(sql);
                        sql = "update HrmResource set "+ DbFunctionUtil.getUpdateSetSql(rs2.getDBType(),Util.getIntValue(operator,0))+",lastmoddate='"+changedate+"',lastmodid='"+operator+"' where id = "+id;
                        rs2.executeSql(sql);

                        HrmFaceCheckManager.sync(id,HrmFaceCheckManager.getOptUpdate(),this.getClass().getName(),HrmFaceCheckManager.getOaResource());

                    }
                }
            }
        } catch (Exception e) {
            writeLog(e);
        }
    }

    private void extendCheck() {//extend
        try {
            //        ResourceComInfo rci = new rci();
            sql = "select id,resourceid,changedate,status,operator from HrmStatusHistory where type_n = 3 and isdispose = 0";
            rs.executeSql(sql);
            while (rs.next()) {
                String id = Util.null2String(rs.getString("resourceid"));
                String changedate = Util.null2String(rs.getString("changedate"));
                String operator = Util.null2String(rs.getString("operator"));
                if (compareDate(changedate)) {
                    if(hasStatueChanged(id, changedate)){
                        continue;
                    }
                    sql = "update HrmStatusHistory set isdispose = 1 where id=" + rs.getString("id");
                    rs2.executeSql(sql);
                    String status = Util.null2String(rs.getString("status"));
                    //          String oldstatus = rci.getStatus(id);
                    //          if(!oldstatus.equals(status)){
                    sql = "update HrmResource set status = " + status + " where id = " + id;
                    //            System.out.println(sql);
                    rs2.executeSql(sql);
                    sql = "update HrmResource set "+ DbFunctionUtil.getUpdateSetSql(rs2.getDBType(),Util.getIntValue(operator,0))+",lastmoddate='"+changedate+"',lastmodid='"+operator+"' where id = "+id;
                    rs2.executeSql(sql);
                    //          }
                    orgCom.checkUser(Integer.parseInt(id));

                    HrmFaceCheckManager.sync(id,HrmFaceCheckManager.getOptUpdate(),this.getClass().getName(),HrmFaceCheckManager.getOaResource());
                }
            }
        } catch (Exception e) {
            writeLog(e);
        }
    }

    private void redeployCheck() {//调动
        try {
            Date newdate = new Date() ;
            long datetime = newdate.getTime() ;
            Timestamp timestamp = new Timestamp(datetime) ;
            String CurrentDate = (timestamp.toString()).substring(0,4) + "-" + (timestamp.toString()).substring(5,7) + "-" +(timestamp.toString()).substring(8,10);
            String currentTime = (timestamp.toString()).substring(11,19);
            RecordSet rs2 = new RecordSet();
            //        ResourceComInfo rci = new ResourceComInfo();
            String id = null;
            String changedate = null;
            String ischangesalary = null;
            String oldjoblevel=null;
            String joblevel = null;
            String oldjobtitleid=null;
            String jobtitle = null;
            int oldDepartmentId=0;
            int oldSubcompanyId=0;
            int newDepartmentId=0;
            int newSubcompanyId=0;

            String newmanagerid = null;
            String oldmanagerid = null;
            String newseclevel = null;
            String newmanagerstr = null;

            int currentsubcompanyid1=0;
            int currentdepartmentid=0;
            String currentmanagerid=null;
            String currentjobtitle=null;
            String currentjoblevel=null;
            String operator = null;

            DepartmentComInfo dci = new DepartmentComInfo();
            sql = "select * from HrmStatusHistory where type_n = 4 and isdispose = 0  order by id asc";
            rs.executeSql(sql);
            while (rs.next()) {
                id = Util.null2String(rs.getString("resourceid"));
                changedate = Util.null2String(rs.getString("changedate"));
                ischangesalary = Util.null2String(rs.getString("ischangesalary"));
                oldDepartmentId = Util.getIntValue(rs.getString("oldDepartmentId"),-1);
                oldSubcompanyId = Util.getIntValue(rs.getString("oldSubcompanyId"),-1);
                newDepartmentId = Util.getIntValue(rs.getString("newDepartmentId"),-1);
                newSubcompanyId = Util.getIntValue(rs.getString("newSubcompanyId"),-1);
                operator = Util.null2String(rs.getString("operator"));
                if (compareDate(changedate)) {
                    if(hasStatueChanged(id, changedate)){
                        continue;
                    }
                    oldjoblevel = Util.null2String(rs.getString("oldjoblevel"));
                    joblevel = Util.null2String(rs.getString("newjoblevel"));
                    oldjobtitleid = Util.null2String(rs.getString("oldjobtitleid"));
                    jobtitle = Util.null2String(rs.getString("newjobtitleid"));
                    newmanagerid = Util.null2String(rs.getString("newmanagerid"));
                    oldmanagerid = Util.null2String(rs.getString("oldmanagerid"));

                    currentsubcompanyid1=0;
                    currentdepartmentid=0;
                    currentmanagerid=null;
                    currentjobtitle=null;
                    currentjoblevel=null;

                    rs2.executeSql("select subcompanyid1,departmentid,managerid,jobtitle,joblevel from hrmresource where id="+id);
                    if(rs2.next()){
                        currentsubcompanyid1 = Util.getIntValue(rs2.getString("subcompanyid1"),-1);
                        currentdepartmentid = Util.getIntValue(rs2.getString("departmentid"),-1);
                        currentmanagerid = Util.null2String(rs2.getString("managerid"));
                        currentjobtitle = Util.null2String(rs2.getString("jobtitle"));
                        currentjoblevel = Util.null2String(rs2.getString("joblevel"));
                    }

                    if(newmanagerid.trim().equals("")&&oldmanagerid.trim().equals("")&&currentmanagerid!=null&&(!currentmanagerid.trim().equals(""))){
                        newmanagerid=currentmanagerid;
                        oldmanagerid=currentmanagerid;
                    }
                    if(jobtitle.trim().equals("")&&oldjobtitleid.trim().equals("")&&currentjobtitle!=null&&(!currentjobtitle.trim().equals(""))){
                        jobtitle=currentjobtitle;
                        oldjobtitleid=currentjobtitle;
                    }
                    if(joblevel.trim().equals("")&&oldjoblevel.trim().equals("")&&currentjoblevel!=null&&(!currentjoblevel.trim().equals(""))){
                        joblevel=currentjoblevel;
                        oldjoblevel=currentjoblevel;
                    }
                    int depid = 0;
                    int costcenterid = 0;
                    if(newDepartmentId>0){
                        depid=newDepartmentId;
                    }else{
                        sql = "select jobdepartmentid from HrmJobTitles where id = " + jobtitle;
                        rs2.executeSql(sql);
                        while (rs2.next()) {
                            depid = Util.getIntValue(rs2.getString("jobdepartmentid"), 0);
                        }
                    }

                    if(depid<=0&&currentdepartmentid>0){
                        depid=currentdepartmentid;
                        newDepartmentId=currentdepartmentid;
                        oldDepartmentId=currentdepartmentid;
                    }

                    sql = "select id from HrmCostcenter where departmentid = " + depid + " order by id";
                    rs2.executeSql(sql);
                    while (rs2.next()) {
                        costcenterid = Util.getIntValue(rs2.getString("id"), 0);
                    }
                    String para = "" + id + separator + depid + separator + joblevel + separator + costcenterid + separator + jobtitle + separator + newmanagerid;

                    rs2.executeProc("HrmResource_DepUpdate", para);
                    sql = "update HrmStatusHistory set isdispose = 1 where id="+rs.getString("id");
                    rs2.executeSql(sql);
                    sql = "update HrmResource set "+ DbFunctionUtil.getUpdateSetSql(rs2.getDBType(),Util.getIntValue(operator,0))+",lastmoddate='"+changedate+"',lastmodid='"+operator+"' where id = "+id;
                    rs2.executeSql(sql);

                    String managerstr = "";
                    if(!id.equals(newmanagerid)){
                        rs2.executeSql("select managerstr from HrmResource where id = "+Util.getIntValue(newmanagerid));
                        if(rs2.next()){
                            managerstr = rs2.getString("managerstr");
                            if(!managerstr.startsWith(","))managerstr=","+managerstr;
                            if(!managerstr.endsWith(","))managerstr=managerstr+",";
                            managerstr =","+newmanagerid+managerstr;
                            managerstr =managerstr.endsWith(",")?managerstr:(managerstr+",");
                        }
                    }else{
                        managerstr =","+newmanagerid+",";
                    }
                    para = ""+id+separator+ managerstr;
                    rs2.executeProc("HrmResource_UpdateManagerStr",para);

                    String subcmpanyid1 = null;
                    if(newSubcompanyId>0){
                        subcmpanyid1=""+newSubcompanyId;
                    }else{
                        sql = "select subcompanyid1 from HrmDepartment where id=" + depid;
                        rs2.executeSql(sql);
                        while (rs2.next()) {
                            subcmpanyid1 = Util.null2String(rs2.getString("subcompanyid1"));
                        }
                    }

                    if((subcmpanyid1==null||subcmpanyid1.trim().equals(""))&&currentsubcompanyid1>0){
                        subcmpanyid1=String.valueOf(currentsubcompanyid1);
                        newSubcompanyId=currentsubcompanyid1;
                        oldSubcompanyId=currentsubcompanyid1;
                    }

                    para = "" + id + separator + subcmpanyid1;
                    rs2.executeProc("HrmResource_UpdateSubCom", para);

                    if(oldDepartmentId!=newDepartmentId||oldSubcompanyId!=newSubcompanyId){
                        rs2.executeSql("select managerid, seclevel, managerstr  from HrmResource where id=" + id);
                        if(rs2.next()){
                            newmanagerid = rs2.getString("managerid");
                            newseclevel = rs2.getString("seclevel");
                            newmanagerstr = rs2.getString("managerstr");
                        }
                        String p_para = id + separator + depid + separator + subcmpanyid1 + separator + newmanagerid + separator + newseclevel + separator + newmanagerstr + separator + oldDepartmentId + separator + oldSubcompanyId + separator + oldmanagerid + separator + newseclevel + separator + newmanagerstr + separator + "1";

                        //System.out.println(p_para);
                        rs2.executeProc("HrmResourceShare", p_para);
                    }

                    if (ischangesalary.equals("1")) {
                        rci.updateResourceInfoCache(id);
                        SalaryManager sm = new SalaryManager();
                        sm.initResourceSalary(id);
                    }

                    boolean exist = orgCom.checkUser(Integer.parseInt(id));
                    if(exist){
                        orgCom.editUser(Integer.parseInt(id));
                    } else {
                        orgCom.addUser(Integer.parseInt(id));
                    }

                    //OA与第三方接口单条数据同步方法开始
                    hrmaction.SynInstantHrmResource(id,"2");
                    //OA与第三方接口单条数据同步方法结束
                    HrmFaceCheckManager.sync(id,HrmFaceCheckManager.getOptUpdate(),this.getClass().getName(),HrmFaceCheckManager.getOaResource());
                }
            }
        } catch (Exception e) {
            writeLog(e);
        }
    }

    private void trainLayoutAssessCheck() {//培训规划考评
        try {
            //            sql = "select * from HrmTrainLayout where datediff(day,layouttestdate,getDate()) = 0";
            sql = "select * from HrmTrainLayout";

            rs.executeSql(sql);
            while (rs.next()) {
                String testdate = Util.null2String(rs.getString("layouttestdate"));
                /*Modified By Charoes Huang On May 18,2004
                 * When Util.dayDiff(startdate,enddate) ==1, then startdate = enddate
                 * When enddate is null, then return 0
                 */
                if (Util.dayDiff(today, testdate) != 1) continue;
                String assessor = Util.null2String(rs.getString("layoutassessor"));
                String id = rs.getString("id");
                String name = rs.getString("layoutname");
                //		String CurrentUser = ""+user.getUID();
                //    	String CurrentUserName = ""+user.getUsername();

                String accepter = "";
                String title = "";
                String remark = "";
                String submiter = "";
                String subject = "";

                subject = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(16162, ThreadVarLanguage.getLang())+"", 7, "0");
                subject += ":" + name;
                accepter = assessor;
                title = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(16162, ThreadVarLanguage.getLang())+"", 7, "0");
                title += ":" + name;
                title += ": ";
                title += "-" + today;
                remark = "<a href='"+ GCONST.getContextPath()+"/hrm/train/trainlayout/HrmTrainLayoutEdit.jsp?id=" + id + "'>" + Util.fromScreen2(subject, 7) + "</a>";
                submiter = "1";
                srwf.setPrjSysRemind(title, 0, Util.getIntValue(submiter), accepter, remark);
            }
        } catch (Exception e) {
            writeLog(e);
        }
    }

    private void trainAssessCheck() {//培训考评
        try {
            TrainComInfo tci = new TrainComInfo();
            //        sql = "select id,organizer,createrid,name from HrmTrain where datediff(day,testdate,getDate()) = 0";
            sql = "select id,organizer,createrid,name,testdate from HrmTrain ";
            rs.executeSql(sql);
            while (rs.next()) {
                String testdate = Util.null2String(rs.getString("testdate"));
                /**
                 * Modified by Charoes Huang ON May 18,2004
                 *
                 */
                if (Util.dayDiff(today, testdate) != 1) continue;

                String organizer = Util.null2String(rs.getString("organizer"));
                String id = rs.getString("id");
                String name = rs.getString("name");
                String creater = rs.getString("createrid");
                String assessor = tci.getActor(id) + organizer + "," + creater;

                String accepter = "";
                String title = "";
                String remark = "";
                String submiter = "";
                String subject = "";

                subject = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(16156, ThreadVarLanguage.getLang())+"", 7, "0");
                subject += ":" + name;
                accepter = assessor;
                title = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(16156, ThreadVarLanguage.getLang())+"", 7, "0");
                title += ":" + name;
                title += ": ";
                title += "-" + today;
                remark = "<a href='"+ GCONST.getContextPath()+"/hrm/train/train/HrmTrainEdit.jsp?id=" + id + "'>" + Util.fromScreen2(subject, 7) + "</a>";
                submiter = creater;
                srwf.setPrjSysRemind(title, 0, Util.getIntValue(submiter), accepter, remark);
            }
        } catch (Exception e) {
            writeLog(e);
        }
    }

    private void interviewAssessCheck() {//面试考核

        try {
            RecordSet RecorcSet = new RecordSet();
            //        sql = "select * from HrmCareerInviteStep where datediff(day,informdate,getDate()) = 0";
            sql = "select * from HrmCareerInviteStep ";
            RecorcSet.executeSql(sql);
            while (RecorcSet.next()) {
                String informdate = Util.null2String(RecorcSet.getString("informdate"));
                /**
                 * Modified by Charoes Huang on May 18,2004
                 */
                if (Util.dayDiff(today, informdate) != 1) continue;

                String assessor = Util.null2String(RecorcSet.getString("assessor"));
                String name = RecorcSet.getString("name");
                String inviteid = Util.null2String(RecorcSet.getString("inviteid"));
                //			System.out.println("The inviteid is "+inviteid);
                String jobtitle = getJobTitleByInvite(inviteid);
                String id = getCareerPlanByInvite(inviteid);

                String accepter = "";
                String title = "";
                String remark = "";
                String submiter = "";
                String subject = "";
                /* commentd by Huang Yu On May 19,2004
               subject=Util.toScreen("面试考核通知",7,"0");
               subject+=":"+name;
               accepter = assessor;
               title = Util.toScreen("面试考核通知",7,"0");
               title += ":"+name;
               title += ": ";
               title += "-"+today;
               remark="<a href=/hrm/career/HrmCareerApplyList.jsp?jobtitle="+jobtitle+"&id="+id+">"+Util.fromScreen2(subject,7)+"</a>";
               submiter="0";
               srwf.setPrjSysRemind(title,0,Util.getIntValue(submiter),accepter,remark);
               */
            }
        } catch (Exception e) {
            writeLog(e);
        }

    }

    private boolean compareDate(String changeday) {
        if (changeday.compareTo(today) <= 0 || changeday.equals(today)) {
            return true;
        }
        return false;
    }

    private Calendar changeStringToDate(String changeday) {
        Calendar date = Calendar.getInstance();
        int year = Util.getIntValue(changeday.substring(0, 4));
        int month = Util.getIntValue(changeday.substring(5, 7));
        int day = Util.getIntValue(changeday.substring(8, 10));
        date.set(year, month, day);
        return date;
    }

    private boolean isToday(String testdate) {
        if (testdate.compareTo(today) == 0) {
            return true;
        }
        return false;
    }

    public String getJobTitleByInvite(String inviteid) {
        String jobtitle = "";
        try {
            String sql = "select careername from HrmCareerInvite where id = " + inviteid;

            rs.executeSql(sql);
            rs.next();
            jobtitle = Util.null2String(rs.getString("careername"));
        } catch (Exception e) {
            writeLog(e);
        }
        return jobtitle;
    }

    public String getCareerPlanByInvite(String inviteid) {
        String plan = "";
        try {
            String sql = "select careerplanid from HrmCareerInvite where id = " + inviteid;

            rs.executeSql(sql);
            rs.next();
            plan = Util.null2String(rs.getString("careerplanid"));
        } catch (Exception e) {
            writeLog(e);
        }
        return plan;
    }


    private int getAccepterSysLanguage(String id) {//得到接受者的语言
        sql = "select systemlanguage from HrmResource where id  =" + id;

        rs.executeSql(sql);
        if (rs.next()) return Util.getIntValue(rs.getString(1));
        return 7;
    }

    private void examineCheck() {

        try {
            Calendar checkstartdates = Calendar.getInstance();
            Calendar checkenddates = Calendar.getInstance();//add by fanggsh 20060816 for TD4825
            String currentdate = Util.add0(checkstartdates.get(Calendar.YEAR), 4) + "-" +
                    Util.add0(checkstartdates.get(Calendar.MONTH) + 1, 2) + "-" +
                    Util.add0(checkstartdates.get(Calendar.DAY_OF_MONTH), 2);
            sql = "select * from HrmCheckKind ";
            rs3.executeSql(sql);
            while (rs3.next()) {
                String id = Util.null2String(rs3.getString("id"));
                String kindname = Util.null2String(rs3.getString("kindname"));
                String checkcycle = Util.null2String(rs3.getString("checkcycle"));
                int checkexpecd = Util.getIntValue(rs3.getString("checkexpecd"), 1);
                String checkstartdate = Util.null2String(rs3.getString("checkstartdate"));

                int startyear = Util.getIntValue(checkstartdate.substring(0, 4));
                int startmonth = Util.getIntValue(checkstartdate.substring(5, 7));
                int startday = Util.getIntValue(checkstartdate.substring(8, 10));

                checkstartdates.set(startyear, startmonth - 1, startday);
                checkenddates.set(startyear, startmonth - 1, startday); //add by fanggsh 20060816 for TD4825
                int loopstep = 0;
                if (checkcycle.equals("1")) {
                    loopstep = 1;
                } else if (checkcycle.equals("2")) {
                    loopstep = 3;
                } else if (checkcycle.equals("3")) {
                    loopstep = 6;
                } else if (checkcycle.equals("4")) {
                    loopstep = 12;
                }

                //add by fanggsh 20060816 for TD4825   begin
                boolean hasNotExamined=true;
                rs2.executeSql(" select 1 from HrmCheckList where checkTypeId="+id+" and startDate<='"+currentdate+"' and endDate>='"+currentdate+"' ");
                if(rs2.next()){
                    hasNotExamined=false;
                }
                //add by fanggsh 20060816 for TD4825   end

                while (checkstartdate.compareTo(currentdate) <= 0) {

                    //update by fanggsh 20060816 for TD4825   begin
                    //制定了考核方案，并且开始进行考核时，本月的考核无法出现

                    //if (checkstartdate.equals(currentdate)) {
                    //    checkstartdates.add(Calendar.DATE, checkexpecd - 1); //Modified by Charoes Huang, 天数从当天算起
                    //    String enddate = Util.add0(checkstartdates.get(Calendar.YEAR), 4) + "-" +
                    //            Util.add0(checkstartdates.get(Calendar.MONTH) + 1, 2) + "-" +
                    //            Util.add0(checkstartdates.get(Calendar.DAY_OF_MONTH), 2);
                    //    String startdate = checkstartdate;
                    //    String checkname = kindname + " " + checkstartdate + "~" + enddate;
                    //    String status = "1";
                    //    String para = checkname + separator + id + separator
                    //            + startdate + separator + enddate + separator + status;
                    //    rs2.executeProc("HrmCheckList_Insert", para);

                    //    if (rs2.next()) {
                    //        String checklistid = rs2.getString(1);
                    //        examineNotice(id, checklistid, checkname);
                    //    }
                    //    break;
                    //}

                    String startdate = checkstartdate;
                    startyear = Util.getIntValue(checkstartdate.substring(0, 4));
                    startmonth = Util.getIntValue(checkstartdate.substring(5, 7));
                    startday = Util.getIntValue(checkstartdate.substring(8, 10));
                    checkenddates.set(startyear, startmonth - 1, startday);
                    checkenddates.add(Calendar.DATE, checkexpecd - 1);
                    String enddate = Util.add0(checkenddates.get(Calendar.YEAR), 4) + "-" +
                            Util.add0(checkenddates.get(Calendar.MONTH) + 1, 2) + "-" +
                            Util.add0(checkenddates.get(Calendar.DAY_OF_MONTH), 2);


                    if (startdate.compareTo(currentdate) <= 0&&currentdate.compareTo(enddate) <= 0&&hasNotExamined) {

                        String checkname = kindname + " " + checkstartdate + "~" + enddate;
                        String status = "1";
                        String para = checkname + separator + id + separator
                                + startdate + separator + enddate + separator + status;
                        rs2.executeProc("HrmCheckList_Insert", para);

                        if (rs2.next()) {
                            String checklistid = rs2.getString(1);
                            examineNotice(id, checklistid, checkname);
                        }
                        break;
                    }

                    //update by fanggsh 20060816 for TD4825   end

                    checkstartdates.add(Calendar.MONTH, loopstep);
                    checkstartdate = Util.add0(checkstartdates.get(Calendar.YEAR), 4) + "-" +
                            Util.add0(checkstartdates.get(Calendar.MONTH) + 1, 2) + "-" +
                            Util.add0(checkstartdates.get(Calendar.DAY_OF_MONTH), 2);



                }
            }
        } catch (Exception e) {
            writeLog(e);
        }
    }


    private void examineNotice(String checktypeid, String checklistid, String checkname) {

        try {
            //           ResourceComInfo rci = new ResourceComInfo();

            ArrayList typeids = new ArrayList();
            ArrayList theresourseids = new ArrayList();
            ArrayList checkproportions = new ArrayList();

            sql = "select t1.typeid,t1.resourceid,t1.checkproportion from HrmCheckActor t1 where  t1.checktypeid=" + checktypeid;
            rs.executeSql(sql);
            while (rs.next()) {
                typeids.add(Util.null2String(rs.getString("typeid")));
                theresourseids.add(Util.null2String(rs.getString("resourceid")));
                checkproportions.add(Util.null2String(rs.getString("checkproportion")));
            }

            ArrayList checkresourceids = new ArrayList();
            ArrayList proprtions = new ArrayList();
            ArrayList checkresourcetypes = new ArrayList();

            RecordSet rs4 = new RecordSet();
            //Modified by Charoes Huang ,June 2,2004. 只有在职的人可以被考核
            sql = "select id from HrmResource where Status in (0,1,2,3) and jobtitle in ( select jobid from HrmCheckPost where checktypeid=" + checktypeid + ")";
            rs4.executeSql(sql);
            List<String> typeidList = null;
            while (rs4.next()) {
                String resourceid = Util.null2String(rs4.getString("id"));
                checkresourceids.clear();
                proprtions.clear();
                checkresourcetypes.clear();
                typeidList = new ArrayList<String>();

                for (int i = 0; i < typeids.size(); i++) {
                    int checkresourcetype = Util.getIntValue((String) typeids.get(i));
                    String theresourseid = (String) theresourseids.get(i);
                    String checkproportion = (String) checkproportions.get(i);
                    String checkresource = "";

                    switch (checkresourcetype) {
                        case 1:
                            checkresource = resourceid;
                            int checkresourceindex = checkresourceids.indexOf(checkresource);
                            if (checkresourceindex == -1 || !typeidList.contains(""+checkresourcetype)) {
                                checkresourceids.add(checkresource);
                                proprtions.add(checkproportion);
                                checkresourcetypes.add("" + checkresourcetype);
                            } else {
                                int oldproportion = Util.getIntValue((String) proprtions.get(checkresourceindex));
                                int newproportion = Util.getIntValue(checkproportion);

                                if (newproportion > oldproportion) {
                                    proprtions.set(checkresourceindex, checkproportion);
                                    checkresourcetypes.set(checkresourceindex, "" + checkresourcetype);
                                }
                            }
                            break;
                        case 2:
                            sql = " select managerid from HrmResource  where id = " + resourceid;
                            rs2.executeSql(sql);
                            if (rs2.next()) checkresource = Util.null2String(rs2.getString("managerid"));

                            checkresourceindex = checkresourceids.indexOf(checkresource);
                            if (checkresourceindex == -1 || !typeidList.contains(""+checkresourcetype)) {
                                checkresourceids.add(checkresource);
                                proprtions.add(checkproportion);
                                checkresourcetypes.add("" + checkresourcetype);
                            } else {
                                int oldproportion = Util.getIntValue((String) proprtions.get(checkresourceindex));
                                int newproportion = Util.getIntValue(checkproportion);

                                if (newproportion > oldproportion) {
                                    proprtions.set(checkresourceindex, checkproportion);
                                    checkresourcetypes.set(checkresourceindex, "" + checkresourcetype);
                                }
                            }
                            break;
                        case 3:
                            String managerstr = "";
                            sql = "select managerstr from HrmResource  where id = " + resourceid;
                            rs2.executeSql(sql);
                            if (rs2.next()) managerstr = Util.null2String(rs2.getString("managerstr"));
                            String managerids[] = Util.TokenizerString2(managerstr, ",");

                            for (int j = 0; j < managerids.length; j++) {
                                checkresource = Util.null2String(managerids[j]);
                                if (checkresource.equals("")) continue;

                                checkresourceindex = checkresourceids.indexOf(checkresource);
                                if (checkresourceindex == -1 || !typeidList.contains(""+checkresourcetype)) {
                                    checkresourceids.add(checkresource);
                                    proprtions.add(checkproportion);
                                    checkresourcetypes.add("" + checkresourcetype);
                                } else {
                                    int oldproportion = Util.getIntValue((String) proprtions.get(checkresourceindex));
                                    int newproportion = Util.getIntValue(checkproportion);

                                    if (newproportion > oldproportion) {
                                        proprtions.set(checkresourceindex, checkproportion);
                                        checkresourcetypes.set(checkresourceindex, "" + checkresourcetype);
                                    }
                                }
                            }
                            break;
                        case 4:
                            sql = " select id from HrmResource  where managerid = " + resourceid;
                            rs2.executeSql(sql);
                            while (rs2.next()) {
                                checkresource = Util.null2String(rs2.getString("id"));

                                checkresourceindex = checkresourceids.indexOf(checkresource);
                                if (checkresourceindex == -1 || !typeidList.contains(""+checkresourcetype)) {
                                    checkresourceids.add(checkresource);
                                    proprtions.add(checkproportion);
                                    checkresourcetypes.add("" + checkresourcetype);
                                } else {
                                    int oldproportion = Util.getIntValue((String) proprtions.get(checkresourceindex));
                                    int newproportion = Util.getIntValue(checkproportion);

                                    if (newproportion > oldproportion) {
                                        proprtions.set(checkresourceindex, checkproportion);
                                        checkresourcetypes.set(checkresourceindex, "" + checkresourcetype);
                                    }
                                }
                            }
                            break;
                        case 5:
                            managerstr = "";
                            sql = "select managerstr from HrmResource  where id = " + resourceid;
                            rs2.executeSql(sql);
                            if (rs2.next()) managerstr = Util.null2String(rs2.getString("managerstr"));

                            sql = "select id from HrmResource  where managerstr like '" + managerstr + resourceid + ",%' ";
                            rs2.executeSql(sql);
                            while (rs2.next()) {
                                checkresource = Util.null2String(rs2.getString("id"));
                                if (checkresource.equals("")) continue;

                                checkresourceindex = checkresourceids.indexOf(checkresource);
                                if (checkresourceindex == -1 || !typeidList.contains(""+checkresourcetype)) {
                                    checkresourceids.add(checkresource);
                                    proprtions.add(checkproportion);
                                    checkresourcetypes.add("" + checkresourcetype);
                                } else {
                                    int oldproportion = Util.getIntValue((String) proprtions.get(checkresourceindex));
                                    int newproportion = Util.getIntValue(checkproportion);

                                    if (newproportion > oldproportion) {
                                        proprtions.set(checkresourceindex, checkproportion);
                                        checkresourcetypes.set(checkresourceindex, "" + checkresourcetype);
                                    }
                                }
                            }
                            break;
                        case 6:
                            String resourcedepartmentid = rci.getDepartmentID(resourceid);
                            sql = " select id from HrmResource  where departmentid =" + resourcedepartmentid + " and id <> " + resourceid;
                            rs2.executeSql(sql);
                            while (rs2.next()) {
                                checkresource = Util.null2String(rs2.getString("id"));

                                checkresourceindex = checkresourceids.indexOf(checkresource);
                                if (checkresourceindex == -1 || !typeidList.contains(""+checkresourcetype)) {
                                    checkresourceids.add(checkresource);
                                    proprtions.add(checkproportion);
                                    checkresourcetypes.add("" + checkresourcetype);
                                } else {
                                    int oldproportion = Util.getIntValue((String) proprtions.get(checkresourceindex));
                                    int newproportion = Util.getIntValue(checkproportion);

                                    if (newproportion > oldproportion) {
                                        proprtions.set(checkresourceindex, checkproportion);
                                        checkresourcetypes.set(checkresourceindex, "" + checkresourcetype);
                                    }
                                }
                            }
                            break;
                        case 7:
                            int status=Util.getIntValue(rci.getStatus(Util.null2String(theresourseid)));
                            if(status<0 ||status>3) break;
                            checkresource = theresourseid;
                            checkresourceindex = checkresourceids.indexOf(checkresource);
                            if (checkresourceindex == -1 || !typeidList.contains(""+checkresourcetype)) {
                                checkresourceids.add(checkresource);
                                proprtions.add(checkproportion);
                                checkresourcetypes.add("" + checkresourcetype);
                            } else {
                                int oldproportion = Util.getIntValue((String) proprtions.get(checkresourceindex));
                                int newproportion = Util.getIntValue(checkproportion);

                                if (newproportion > oldproportion) {
                                    proprtions.set(checkresourceindex, checkproportion);
                                    checkresourcetypes.set(checkresourceindex, "" + checkresourcetype);
                                }
                            }
                            break;
                    }
                    typeidList.add(Util.null2String(checkresourcetype));
                }

                for (int i = 0; i < checkresourceids.size(); i++) {
                    String checkresourceid = (String) checkresourceids.get(i);
                    String proportion = (String) proprtions.get(i);
                    String propcheckresourcetype = (String) checkresourcetypes.get(i);
                    String checkid = checklistid;
                    String checkresourcetype = propcheckresourcetype;
                    String result = "0";
                    String CheckPeopleid = "";

                    String para = checkid + separator + resourceid + separator
                            + checkresourceid + separator + proportion + separator + checkresourcetype + separator + result;
                    rs2.executeProc("HrmByCheckPeople_Insert", para);
                    if (rs2.next()) CheckPeopleid = Util.null2String(rs2.getString(1));


                    String resourceidname = rci.getResourcename(resourceid);
                    String SWFTitle = checkname + ":" + resourceidname;
                    String SWFRemark = "";
                    String SWFSubmiter = "0";
                    String Subject = SWFTitle;

                    SWFRemark = "<a href='"+ GCONST.getContextPath()+"/hrm/actualize/HrmCheckMark.jsp?id=" + CheckPeopleid + "'>" + Util.fromScreen2(Subject, getAccepterSysLanguage(checkresourceid)) + "</a>";

                    srwf.setPrjSysRemind(SWFTitle, 0, Util.getIntValue(resourceid), checkresourceid, SWFRemark);
                }
            }
        } catch (Exception ex) {
            writeLog(ex);
        }
    }

    /**
     * 删除工作流，文档部分不需要的数据
     */
    public void delWrkMuti() {
        /* 2004-06-22 刘煜增加， 定期删除工作流，文档部分不需要的数据 */
        rs.executeProc("wrkcrt_mutidel", "");
    }

    public void contractTypeRemind() {
        try {
            ChgPasswdReminder reminder = new ChgPasswdReminder();
            RemindSettings settings = reminder.getRemindSettings();
            String contractValid = settings.getContractvalid();//是否开启合同到期提醒
            String contractRemindPeriod = settings.getContractremindperiod();//合同到期提醒提前天数
            String statusWithContract = settings.getStatusWithContract();//合同到期后是否将人员置为“无效”状态
            List sysMemberList = null;
            if (!contractValid.equals("1")) {
                return;
            }
            RecordSet recordSet1 = new RecordSet();
            List excludeList = new ArrayList();//合同到期提醒，对于关联具体合同文本的人员将根据合同类型中绑定的提醒人和设置的提前提醒天数进行提醒
            List excludeList1 = new ArrayList();//试用期到期提醒，对于关联具体合同文本的人员根据合同类型中绑定的提醒人和设置的提前提醒天数进行提醒
            String sql1 = "select HrmContract.id,remindman,proenddate,contractenddate,remindaheaddate,remindtime,contractman,HrmResource.status" +
                    " from HrmContract,HrmContractType,HrmResource where  contracttypeid = HrmContractType.id and " +
                    " HrmResource.id = HrmContract.contractman and HrmResource.status in (0,1,2,3) ";
            recordSet1.executeQuery(sql1);
//        writeLog("ContractPlanningtask>>>sql1="+sql1);
            while (recordSet1.next()) {
                String id = recordSet1.getString(1);//合同维护的ID
                String infoman = recordSet1.getString("remindman");//合同种类中的提醒人
                String contractman = Util.null2String(recordSet1.getString("contractman"));//合同人
                String contractenddate = Util.null2String(recordSet1.getString("contractenddate"));//合同结束日期
                String proenddate = Util.null2String(recordSet1.getString("proenddate"));//试用结束日期
                int remindaheaddate = Util.getIntValue(recordSet1.getString("remindaheaddate"));//合同到期提前提醒天数
                String remindtime = Util.null2String(recordSet1.getString("remindtime"));
				String status = Util.null2String(recordSet1.getString("status"));
                /**
                 * Modified By Charoes Huang    On May 18,2004
                 * Util.dayDiff(startdate ,enddate) 返回的天数比实际多一天！
                 * 即如果 startdate == enddate ，返回 1 ，实际应该是零
                 */
                if (Util.dayDiff(today, contractenddate) != (remindaheaddate + 1) && Util.dayDiff(today, proenddate) != (remindaheaddate + 1)) {
                    continue;
                }
                if (Util.dayDiff(today, contractenddate) == (remindaheaddate + 1)) {
                    if (this.remindTimeDifference(remindtime)) continue;
                    subject = Util.toScreen("" + weaver.systeminfo.SystemEnv.getHtmlLabelName(15783, ThreadVarLanguage.getLang()) + "", 7, "0");
                    subject += ":" + rci.getResourcename(contractman);
                    infoman += ",";
                    ArrayList al = Util.TokenizerString(infoman, ",");
                    for (int i = 0; i < al.size(); i++) {
                        if (!excludeList.contains(al.get(i))) {
                            excludeList.add(al.get(i));
                        }
                        accepter = (String) al.get(i);
                        title = Util.toScreen("" + weaver.systeminfo.SystemEnv.getHtmlLabelName(15783, ThreadVarLanguage.getLang()) + "", 7, "0");
                        title += ": ";
                        title += "-" + rci.getResourcename(contractman);
                        title += "-" + today;
                        remark = "";
                        submiter = "1";
                        srwf.setPrjSysRemind(title, 0, Util.getIntValue(submiter), accepter, remark);
                    }
                }
                if (!"1".equals(status) && Util.dayDiff(today, proenddate) == (remindaheaddate + 1)) {
                    if (this.remindTimeDifference(remindtime)) continue;
                    subject = Util.toScreen("" + weaver.systeminfo.SystemEnv.getHtmlLabelName(10003686, ThreadVarLanguage.getLang()) + "", 7, "0");
                    subject += ":" + rci.getResourcename(contractman);
                    infoman += ",";
                    ArrayList al = Util.TokenizerString(infoman, ",");
                    for (int i = 0; i < al.size(); i++) {
                        if (!excludeList1.contains(al.get(i))) {
                            excludeList1.add(al.get(i));
                        }
                        accepter = (String) al.get(i);
                        title = Util.toScreen("" + weaver.systeminfo.SystemEnv.getHtmlLabelName(10003686, ThreadVarLanguage.getLang()) + "", 7, "0");
                        title += ": ";
                        title += "-" + rci.getResourcename(contractman);
                        title += "-" + today;
                        remark = "";
                        submiter = "1";
                        srwf.setPrjSysRemind(title, 0, Util.getIntValue(submiter), accepter, remark);
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 计算当前时间和提醒时间的差 是否超过五分钟
     * @return
     */
    private boolean remindTimeDifference(String remindTime) {
        DateTimeFormatter dtf = DateTimeFormatter.ofPattern("yyyy-MM-dd ");
        String format = dtf.format(LocalDateTime.now()) + remindTime;
        LocalDateTime parse = LocalDateTime.parse(format, DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm"));
        Duration duration = Duration.between(parse, LocalDateTime.now());
        long minutes = Math.abs(duration.toMinutes());
        if (minutes > 5 || duration.toMinutes()<0)
            return true;
        return false;
    }


    public void contractRemind(){
        try{
            ChgPasswdReminder reminder = new ChgPasswdReminder();
            RemindSettings settings = reminder.getRemindSettings();
            String contractValid = settings.getContractvalid();//是否开启合同到期提醒
            String contractRemindPeriod = settings.getContractremindperiod();//合同到期提醒提前天数
            String statusWithContract = settings.getStatusWithContract();//合同到期后是否将人员置为“无效”状态
            List sysMemberList = null;
            if(!contractValid.equals("1")){
                return ;
            }
//            RecordSet recordSet1 = new RecordSet();
            List excludeList = new ArrayList();//合同到期提醒，对于关联具体合同文本的人员将根据合同类型中绑定的提醒人和设置的提前提醒天数进行提醒
            List excludeList1 = new ArrayList();//试用期到期提醒，对于关联具体合同文本的人员根据合同类型中绑定的提醒人和设置的提前提醒天数进行提醒
//            String sql1 = "select HrmContract.id,remindman,proenddate,contractenddate,remindaheaddate,contractman" +
//                    " from HrmContract,HrmContractType,HrmResource where  contracttypeid = HrmContractType.id and " +
//                    " HrmResource.id = HrmContract.contractman and HrmResource.status in (0,1,2,3) ";
//            recordSet1.executeQuery(sql1);
//            writeLog("ContractPlanningtask>>>sql1="+sql1);
//            while(recordSet1.next()){
//                String id = recordSet1.getString(1);//合同维护的ID
//                String infoman = recordSet1.getString("remindman");//合同种类中的提醒人
//                String contractman = Util.null2String(recordSet1.getString("contractman"));//合同人
//                String contractenddate = Util.null2String(recordSet1.getString("contractenddate"));//合同结束日期
//                String proenddate = Util.null2String(recordSet1.getString("proenddate"));//试用结束日期
//                int remindaheaddate = Util.getIntValue(recordSet1.getString("remindaheaddate"));//合同到期提前提醒天数
//                /**
//                 * Modified By Charoes Huang    On May 18,2004
//                 * Util.dayDiff(startdate ,enddate) 返回的天数比实际多一天！
//                 * 即如果 startdate == enddate ，返回 1 ，实际应该是零
//                 */
//                if (Util.dayDiff(today, contractenddate) != (remindaheaddate + 1) && Util.dayDiff(today, proenddate) != (remindaheaddate + 1)){
//                    continue;
//                }
//                if(Util.dayDiff(today, contractenddate) == (remindaheaddate + 1)){
//                    subject = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(15783,weaver.general.ThreadVarLanguage.getLang())+"", 7, "0");
//                    subject += ":" + rci.getResourcename(contractman);
//                    infoman += ",";
//                    ArrayList al = Util.TokenizerString(infoman, ",");
//                    for (int i = 0; i < al.size(); i++) {
//                        if(!excludeList.contains(al.get(i))){
//                            excludeList.add(al.get(i));
//                        }
//                        accepter = (String) al.get(i);
//                        title = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(15783,weaver.general.ThreadVarLanguage.getLang())+"", 7, "0");
//                        title += ": ";
//                        title += "-" + rci.getResourcename(contractman);
//                        title += "-" + today;
//                        remark = "";
//                        submiter = "1";
//                        srwf.setPrjSysRemind(title, 0, Util.getIntValue(submiter), accepter, remark);
//                    }
//                }
//                if(Util.dayDiff(today, proenddate) == (remindaheaddate + 1)){
//                    subject = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(10003686,weaver.general.ThreadVarLanguage.getLang())+"", 7, "0");
//                    subject += ":" + rci.getResourcename(contractman);
//                    infoman += ",";
//                    ArrayList al = Util.TokenizerString(infoman, ",");
//                    for (int i = 0; i < al.size(); i++) {
//                        if(!excludeList1.contains(al.get(i))){
//                            excludeList1.add(al.get(i));
//                        }
//                        accepter = (String) al.get(i);
//                        title = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(10003686,weaver.general.ThreadVarLanguage.getLang())+"", 7, "0");
//                        title += ": ";
//                        title += "-" + rci.getResourcename(contractman);
//                        title += "-" + today;
//                        remark = "";
//                        submiter = "1";
//                        srwf.setPrjSysRemind(title, 0, Util.getIntValue(submiter), accepter, remark);
//                    }
//                }
//            }
            RecordSet recordSet2 = new RecordSet();
            String sql2 = "select id,enddate,probationenddate,status from HrmResource where status in (0,1,2,3) and (enddate='"+TimeUtil.dateAdd(today, Util.getIntValue(contractRemindPeriod,0))+"' or probationenddate='"+TimeUtil.dateAdd(today, Util.getIntValue(contractRemindPeriod,0))+"')";
            writeLog("ContractPlanningtask>>>sql2="+sql2);
            recordSet2.executeQuery(sql2);
            while(recordSet2.next()){
                String resourceId = Util.null2String(recordSet2.getString("id"));
                String endDate = Util.null2String(recordSet2.getString("endDate"));//合同结束日期
                String probationenddate = Util.null2String(recordSet2.getString("probationenddate"));//试用期结束日期
				String status = Util.null2String(recordSet2.getString("status"));
                if(!endDate.equals("")&& Util.dayDiff(today, endDate) == (Util.getIntValue(contractRemindPeriod,0) + 1)){
                    if(!excludeList.contains(resourceId)){
                        sysMemberList = getSysMembers(resourceId);
                        subject = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(15783, ThreadVarLanguage.getLang())+"", 7, "0");
                        subject += ":" + rci.getResourcename(resourceId);
                        for(int i=0;i<sysMemberList.size();i++){
                            accepter = (String) sysMemberList.get(i);
                            title = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(15783, ThreadVarLanguage.getLang())+"", 7, "0");
                            title += ": ";
                            title += "-" + rci.getResourcename(resourceId);
                            title += "-" + today;
                            remark = "<a href='/hrm/resource/HrmResource.jsp?id="
                                    + resourceId + "'>" + Util.fromScreen2(subject, 7) + "</a>&nbsp;";
                            submiter = "1";
                            writeLog("ContractPlanningtask>>>setPrjSysRemind=start>title="+title+";accepter="+accepter+";remark="+remark+";submiter="+submiter);
                            srwf.setPrjSysRemind(title, 0, Util.getIntValue(submiter), accepter, remark);
                            writeLog("ContractPlanningtask>>>setPrjSysRemind=over");
                        }
                    }
                }
                if(!"1".equals(status) && !probationenddate.equals("") && Util.dayDiff(today, probationenddate) == (Util.getIntValue(contractRemindPeriod,0) + 1)){
                    if(!excludeList1.contains(resourceId)){
                        sysMemberList = getSysMembers(resourceId);
                        subject = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(10003686, ThreadVarLanguage.getLang())+"", 7, "0");
                        subject += ":" + rci.getResourcename(resourceId);
                        for(int i=0;i<sysMemberList.size();i++){
                            accepter = (String) sysMemberList.get(i);
                            title = Util.toScreen(""+weaver.systeminfo.SystemEnv.getHtmlLabelName(10003686, ThreadVarLanguage.getLang())+"", 7, "0");
                            title += ": ";
                            title += "-" + rci.getResourcename(resourceId);
                            title += "-" + today;
                            remark = "<a href='/hrm/resource/HrmResource.jsp?id="
                                    + resourceId + "'>" + Util.fromScreen2(subject, 7) + "</a>&nbsp;";
                            submiter = "1";
                            srwf.setPrjSysRemind(title, 0, Util.getIntValue(submiter), accepter, remark);
                        }
                    }
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    private List getSysMembers(String resourceId) throws Exception{
        List<String> sysMembersList = new ArrayList<String>();
        RecordSet recordSet = new RecordSet();
        String sql = " SELECT * FROM HrmContractShare  ";
        recordSet.executeSql(sql);
        while(recordSet.next()) {
            String sharetype = recordSet.getString("sharetype");//类型
            String relatedshare = "";//对象
            String sharelevel = recordSet.getString("sharelevel");//提醒级别
            String seclevel = "";    //安全级别--小
            String seclevelto = ""; //安全等级--大
            String level = "0";    //角色或者岗位的级别
            String org = "0";      //岗位指定的分部或者部门
            String lowerLevel = "0"; //包含下级

            if (sharetype.equals("1")) {
                //人力资源
                relatedshare = recordSet.getString("userid");
            } else if (sharetype.equals("2")) {
                //分部
                relatedshare = recordSet.getString("subcompanyid");
                lowerLevel = recordSet.getString("lowerLevel");
            } else if (sharetype.equals("3")) {
                //部门
                relatedshare = recordSet.getString("departmentid");
                lowerLevel = recordSet.getString("lowerLevel");
            } else if (sharetype.equals("4")) {
                //角色
                relatedshare = recordSet.getString("roleid");
                level = recordSet.getString("rolelevel");
            } else if (sharetype.equals("7")) {
                //岗位
                relatedshare = recordSet.getString("jobtitleid");
                level = recordSet.getString("jobtitlelevel");
                if (level.equals("1")) org = recordSet.getString("jobsubcompany");
                if (level.equals("2")) org = recordSet.getString("jobdepartment");
            } else if (sharetype.equals("5")) {
                //所有人
                relatedshare = recordSet.getString("foralluser");
            }
            if (!sharetype.equals("1")) {
                seclevelto = HrmTransMethod.getStringValue(recordSet.getString("seclevelto"), "100");
                seclevel = HrmTransMethod.getStringValue(recordSet.getString("seclevel"), "0");
            }

            RecordSet recordSet1 = new RecordSet();
            boolean isoracle = (recordSet1.getDBType()).equals("oracle");
            String sql1 = " select id,departmentid,subcompanyId1 from HrmResource "
                    + " where (accounttype is null or accounttype=0) "
                    + " and (status = 0 or status = 1 or status = 2 or status = 3) " ;
            //增加提醒对象
            if (sharetype.equals("1")) {
                // 人力资源
                sql1 += " and id = " + relatedshare;
            } else if (sharetype.equals("2")) {
                // 分部
                sql1 += " and seclevel>=" + seclevel +"  and seclevel<=" + seclevelto;
                if(lowerLevel.equals("1"))//包含下级
                {
                    sql1+= " and  subcompanyid1 in ("+ SubCompanyComInfo.getAllChildSubcompanyId(relatedshare,relatedshare)+")" ;
                }else{
                    sql1+= " and  subcompanyid1 = " + relatedshare ;
                }
            } else if (sharetype.equals("3")) {
                // 部门
                sql1 += " and seclevel>=" + seclevel +"  and seclevel<=" + seclevelto;
                if(lowerLevel.equals("1"))//包含下级
                {
                    sql1+= " and   departmentid in ("+new DepartmentComInfo().getAllChildDepartId(relatedshare, relatedshare)+")" ;
                }else{
                    sql1+= " and  departmentid = " + relatedshare ;
                }
            } else if (sharetype.equals("4")) {
                // 角色
                //sql+= "  and id in ( select resourceid from HrmRoleMembers where roleid=" + relatedshare + " and rolelevel>="+level+")"+" and seclevel>=" + seclevel +" and seclevel<=" + seclevelto;
                String roleSql = " SELECT distinct resourceid FROM ( "+
                        " SELECT a.id AS resourceid, b.roleid , b.rolelevel FROM HrmResource a, HrmRoleMembers b "+
                        " WHERE (a.id=b.resourceid and b.resourcetype=1) "+
                        " UNION ALL "+
                        " SELECT a.id AS resourceid, b.roleid , b.rolelevel FROM HrmResourceManager a, HrmRoleMembers b "+
                        " WHERE (a.id=b.resourceid and b.resourcetype IN(7,8)) "+
                        " UNION ALL "+
                        " SELECT a.id AS resourceid, b.roleid , b.rolelevel FROM HrmResource a, HrmRoleMembers b "+
                        " WHERE (a.subcompanyid1 = b.resourceid AND a.seclevel>=b.seclevelfrom AND a.seclevel<=b.seclevelto AND b.resourcetype=2) "+
                        " UNION ALL "+
                        " SELECT a.id AS resourceid, b.roleid , b.rolelevel FROM HrmResource a, HrmRoleMembers b "+
                        " WHERE (a.departmentid = b.resourceid AND a.seclevel>=b.seclevelfrom AND a.seclevel<=b.seclevelto AND b.resourcetype=3) "+
                        " UNION ALL "+
                        " SELECT a.id AS resourceid, b.roleid , b.rolelevel FROM HrmResource a, HrmRoleMembers b "+
                        " WHERE  (a.jobtitle = b.resourceid AND b.resourcetype=5 AND (b.jobtitlelevel=1 OR (b.jobtitlelevel=2 AND a.subcompanyid1 IN(b.subdepid)) OR (b.jobtitlelevel=3 AND a.departmentid IN(b.subdepid))))) t "+
                        " WHERE roleid=" + relatedshare + " and rolelevel>="+level+" ";
                sql1+= "  and id in ("+roleSql+")"+" and seclevel>=" + seclevel +" and seclevel<=" + seclevelto;
            } else if (sharetype.equals("7")) {
                // 岗位
                sql1+= " and jobtitle = "+relatedshare+" "+"  and seclevel>=" + seclevel +"  and  seclevel<=" + seclevelto;
                if(level.equals("1")){
                    sql1+= " and  subcompanyid1= " + org ;
                }else if(level.equals("2")){
                    sql1+= " and  departmentid = " + org ;
                }
            } else if (sharetype.equals("5")) {
                // 所有人
                sql1 += " and seclevel>=" + seclevel +"and seclevel<=" + seclevelto;
            }
            writeLog("ContractPlanningtask>>>getresource>sql1="+sql1);
            recordSet1.executeQuery(sql1);
            while(recordSet1.next()){
                String sysMemberId = recordSet1.getString("id");//需要提醒的对象的ID
                String subId = recordSet1.getString("subcompanyid1");//需要提醒的对象的分部ID
                String depId = recordSet1.getString("departmentid");//分部部门
                RecordSet recordSet2 = new RecordSet();
                String sql2 = " select count(id) cnt from HrmResource "
                        + " where (accounttype is null or accounttype=0) "
                        + " and (status = 0 or status = 1 or status = 2 or status = 3) and id="+resourceId;
                if (sharelevel.equals("0")) {
                    // 本部门 指的是和当前对象相同部门的对象
                    sql2 += " and HrmResource.departmentid = " + depId;
                } else if (sharelevel.equals("1")) {
                    // 本部门及上级部门
                    sql2 += " and exists ( select * from hrmdepartment where HrmResource.departmentid= hrmdepartment.id "
                            + " and hrmdepartment.id in ("
                            + DepartmentComInfo.getAllParentDepartId(depId, depId)
                            + "))";
                } else if (sharelevel.equals("2")) {
                    // 本部门及下级部门
                    sql2 += " and exists ( select * from hrmdepartment where HrmResource.departmentid= hrmdepartment.id "
                            + " and hrmdepartment.id in ("
                            + DepartmentComInfo.getAllChildDepartId(depId, depId)
                            + "))";
                } else if (sharelevel.equals("3")) {
                    // 本分部
                    sql2 += " and HrmResource.subcompanyid1 = " + subId;
                } else if (sharelevel.equals("4")) {
                    // 本分部及上级分部
                    sql += " and exists ( select * from HrmSubCompany where HrmResource.subcompanyid1= HrmSubCompany.id "
                            + " and HrmSubCompany.id in ("
                            + SubCompanyComInfo.getAllParentSubcompanyId(subId,
                            subId) + "))";
                } else if (sharelevel.equals("5")) {
                    // 本分部及下级分部
                    sql2 += " and exists ( select * from HrmSubCompany where HrmResource.subcompanyid1= HrmSubCompany.id "
                            + " and HrmSubCompany.id in ("
                            + SubCompanyComInfo.getAllChildSubcompanyId(subId,
                            subId) + "))";
                }
                writeLog("ContractPlanningtask>>>getresource>sql2="+sql2);
                recordSet2.executeQuery(sql2);
                if(recordSet2.next()){
                    if(recordSet2.getInt("cnt")>0){
                        if(!sysMembersList.contains(sysMemberId)){
                            sysMembersList.add(sysMemberId);
                        }
                    }
                }
            }
        }
        writeLog("ContractPlanningtask>>>sysMembersList="+ JSON.toJSONString(sysMembersList));
        return sysMembersList;
    }

    public void checkUsbAutoDate() {
        try {
            HrmUsbAutoDateManager manager = null;
            Map<String, Comparable> map = null;
            manager = new HrmUsbAutoDateManager();
            map = new HashMap<String, Comparable>();
            map.put("needAuto", 1);
            map.put("delflag", 0);
            map.put("enableDate", DateUtil.getCurrentDate());
            List<HrmUsbAutoDate> list = manager.find(map);
            if (list != null && list.size() > 0) {
                StringBuffer ids = new StringBuffer();
                for (HrmUsbAutoDate bean : list) {
                    StringBuffer upSql = new StringBuffer("update ")
                            .append(bean.isAdmin() ? "HrmResourceManager" : "HrmResource")
                            .append(" set usbstate = ").append(bean.getEnableUsbType())
                            .append(" where id = ").append(bean.getUserId());
                    rs.executeSql(upSql.toString());
                    ids.append(StringUtil.isNull(ids.toString()) ? "" : ",").append(bean.getId());
                }
                if (StringUtil.isNotNull(ids.toString())) {
                    manager.delete(ids.toString());
                }
            }
        } catch (Exception e) {
            writeLog(e);
        }
    }

    /**
     * 计算离职人员工龄、司龄计算
     */
    public void calDismissWorkInfo(String resourceid){
//        String sql = "";
//        RecordSet rs = new RecordSet();
//        try{
//            //更新离职日期
//            sql = " UPDATE HrmResource SET dismissdate = (SELECT MAX(changedate) FROM HrmStatusHistory WHERE hrmresource.id=resourceid) WHERE STATUS=5  ";
//            if(resourceid.length()>0){
//                sql += " and id= "+resourceid;
//            }
//            rs.executeUpdate(sql);
//
//            if(rs.getDBType().equals("oracle")){
//                //计算工龄
//                sql = " UPDATE HrmResource SET workyear=(TO_DATE(dismissdate,'yyyy-mm-dd')-TO_DATE(workstartdate,'yyyy-mm-dd'))/365.0 WHERE status = 5 ";
//                if(resourceid.length()>0){
//                    sql += " and id= "+resourceid;
//                }
//                rs.executeUpdate(sql);
//
//                //计算司龄
//                sql = " UPDATE HrmResource SET companyworkyear=(TO_DATE(dismissdate,'yyyy-mm-dd')-TO_DATE(companystartdate,'yyyy-mm-dd'))/365.0 WHERE status = 5 ";
//                if(resourceid.length()>0){
//                    sql += " and id= "+resourceid;
//                }
//                rs.executeUpdate(sql);
//            }else if(rs.getDBType().equals("mysql")){
//                //计算工龄
//                sql = " UPDATE HrmResource SET workyear=DATEDIFF(dismissdate,workstartdate)/365.0 WHERE status = 5 ";
//                if(resourceid.length()>0){
//                    sql += " and id= "+resourceid;
//                }
//                rs.executeUpdate(sql);
//
//                //计算司龄
//                sql = " UPDATE HrmResource SET companyworkyear=DATEDIFF(companystartdate,workstartdate)/365.0 WHERE status = 5 ";
//                if(resourceid.length()>0){
//                    sql += " and id= "+resourceid;
//                }
//                rs.executeUpdate(sql);
//            }else{
//                //计算工龄
//                sql = " UPDATE HrmResource SET workyear=datediff(day,workstartdate,dismissdate)/365.0 WHERE status = 5 " +
//                        " and (workstartdate is not null and workstartdate<> '' and dismissdate is not null and dismissdate<> '')";
//                if(resourceid.length()>0){
//                    sql += " and id= "+resourceid;
//                }
//                rs.executeUpdate(sql);
//
//                //计算司龄
//                sql = " UPDATE HrmResource SET companyworkyear=datediff(day,companystartdate,dismissdate)/365.0 WHERE status = 5 "+
//                        " and (companystartdate is not null and companystartdate<> '' and dismissdate is not null and dismissdate<> '')";
//                if(resourceid.length()>0){
//                    sql += " and id= "+resourceid;
//                }
//                rs.executeUpdate(sql);
//
//            }
//        }catch (Exception e){
//            writeLog(e);
//        }
    }
    /**
     * 工龄、司龄计算(该方法只提供给 HrmDateCheck使用，其他地方请勿调用该方法)
     */
    @Deprecated
    public void calWorkInfo(){
        writeLog("calWorkInfo begin>>>>>>>>>"+DateUtil.getFullDate());
        ResourceComInfo rs = new ResourceComInfo(true);
        while(rs.next()) {
            try {
                String status = Util.null2String(rs.getStatus());
                if(status.equals("0")||status.equals("1")||status.equals("2")||status.equals("3")) {
                    //计算在职人员工龄、司龄
                    calWorkInfo(rs.getResourceid());
                }
            }catch (Exception e){
                this.writeLog(e);
            }
        }
        rs.removeResourceCache();
        writeLog("calWorkInfo end>>>>>>>>>"+DateUtil.getFullDate());
    }

    /**
     * 工龄、司龄计算
     */
    public void calWorkInfo(String resourceid){
        writeLog("calWorkInfo resourceid >>>>>>>>>"+ resourceid);
        String sql = "";
        RecordSet rs = new RecordSet();
        try{
            if(Util.getIntValue(resourceid)<=0){
                //无效的人员id
                return;
            }
            String currentdate = DateUtil.getCurrentDate();
            String workstartdate = "";
            String companystartdate = "";
            String status = "";
            String dismissdate = "";
            double workyear = 0;
            double companyworkyear = 0;


            sql = " select workstartdate, companystartdate,status from HrmResource where id = ?";
            rs.executeQuery(sql,resourceid);
            if(rs.next()){
                workstartdate = Util.null2String(rs.getString("workstartdate"));
                companystartdate = Util.null2String(rs.getString("companystartdate"));
                status = Util.null2String(rs.getString("status"));
            }

            if(status.equals("5")) {
                sql = " SELECT MAX(changedate) as dismissdate FROM HrmStatusHistory WHERE resourceid= ? ";
                rs.executeQuery(sql, resourceid);
                if (rs.next()) {
                    dismissdate = rs.getString("dismissdate");
                }
            }

            //离职人员只计算到离职日期
            currentdate = dismissdate.length()>0?dismissdate:currentdate;

            if(workstartdate.length()>0){
                workstartdate = DateUtil.compDate(currentdate,workstartdate)>0?currentdate:workstartdate;
                workyear = DateUtil.dayDiff(workstartdate,currentdate)/365.0;
            }

            if(companystartdate.length()>0){
                companystartdate = DateUtil.compDate(currentdate,companystartdate)>0?currentdate:companystartdate;
                companyworkyear = DateUtil.dayDiff(companystartdate,currentdate)/365.0;
            }

            //计算中间有离职记录的人员
            List<String> lsChangeDate = new ArrayList<>();
            String dismissdatetemp = "";
            String pre_type_n = "";
            sql = " SELECT changedate, type_n FROM HrmStatusHistory where resourceid = ? and type_n in (5,7) AND isdispose = 1 order by changedate asc ";
            rs.executeQuery(sql, resourceid);
            while (rs.next()) {
                String changedate = Util.null2String(rs.getString("changedate"));
                String type_n = Util.null2String(rs.getString("type_n"));
                if (lsChangeDate.size() == 0) {
                    if (type_n.equals("1") || type_n.equals("5") || type_n.equals("6") || type_n.equals("9")) {
                        dismissdatetemp = changedate;
                        lsChangeDate.add(changedate);
                    }
                } else {
                    if (!pre_type_n.equals(type_n)) {
                        lsChangeDate.add(changedate);
                    }
                }
                pre_type_n = type_n;
            }
            if(dismissdatetemp.length()>0 && DateUtil.compDate(dismissdatetemp,companystartdate)<0) {
                if (!lsChangeDate.isEmpty()) {
                    if (lsChangeDate.size() % 2 == 1) {
                        lsChangeDate.remove(lsChangeDate.size() - 1);
                    }
                    for (int i = 0; i < lsChangeDate.size(); ) {
                        String fromdate = lsChangeDate.get(i);
                        String todate = lsChangeDate.get(i + 1);
                        double tmp = DateUtil.dayDiff(fromdate, todate) / 365.0;
                        if (tmp > 0) {
                            companyworkyear = companyworkyear - tmp;
                        }
                        i = i + 2;
                    }
                }
            }
			//如果companystartdate为空，则清空companyworkyear
            if(companystartdate.length()==0){
                companyworkyear = 0;
            }

            //更新工龄 司龄
            sql = " UPDATE HrmResource SET workyear=?, companyworkyear=?,dismissdate=? where id = ? ";
            rs.executeUpdate(sql,workyear,companyworkyear,dismissdate,resourceid);

        }catch (Exception e){
            writeLog(e);
        }
    }

    public void calKqData(String fromdate,String todate,String resourceid){
        KQFormatData kqFormatData = new KQFormatData();
        if(resourceid.length()>0 && fromdate.length()>0 && todate.length()>0) {
            Calendar cal = DateUtil.getCalendar();
            if (DateUtil.timeInterval(todate, fromdate) > 0) {
                return;
            }

            boolean isEnd = false;
            for (String date = fromdate; !isEnd; ) {
                if (date.equals(todate)) isEnd = true;
                kqFormatData.formatKqDate(resourceid, date);
                cal.setTime(DateUtil.parseToDate(date));
                date = DateUtil.getDate(cal.getTime(), 1);
            }
        }
    }
}
